"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _AutomationToken = _interopRequireDefault(require("./AutomationToken"));
var _AutomationTokenResponseAllOf = _interopRequireDefault(require("./AutomationTokenResponseAllOf"));
var _ReadOnlyCustomerId = _interopRequireDefault(require("./ReadOnlyCustomerId"));
var _ReadOnlyId = _interopRequireDefault(require("./ReadOnlyId"));
var _Timestamps = _interopRequireDefault(require("./Timestamps"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The AutomationTokenResponse model module.
 * @module model/AutomationTokenResponse
 * @version 7.4.0
 */
var AutomationTokenResponse = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>AutomationTokenResponse</code>.
   * @alias module:model/AutomationTokenResponse
   * @implements module:model/AutomationToken
   * @implements module:model/Timestamps
   * @implements module:model/AutomationTokenResponseAllOf
   */
  function AutomationTokenResponse() {
    _classCallCheck(this, AutomationTokenResponse);
    _AutomationToken["default"].initialize(this);
    _Timestamps["default"].initialize(this);
    _AutomationTokenResponseAllOf["default"].initialize(this);
    AutomationTokenResponse.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(AutomationTokenResponse, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>AutomationTokenResponse</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/AutomationTokenResponse} obj Optional instance to populate.
     * @return {module:model/AutomationTokenResponse} The populated <code>AutomationTokenResponse</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new AutomationTokenResponse();
        _AutomationToken["default"].constructFromObject(data, obj);
        _Timestamps["default"].constructFromObject(data, obj);
        _AutomationTokenResponseAllOf["default"].constructFromObject(data, obj);
        if (data.hasOwnProperty('name')) {
          obj['name'] = _ApiClient["default"].convertToType(data['name'], 'String');
        }
        if (data.hasOwnProperty('role')) {
          obj['role'] = _ApiClient["default"].convertToType(data['role'], 'String');
        }
        if (data.hasOwnProperty('services')) {
          obj['services'] = _ApiClient["default"].convertToType(data['services'], ['String']);
        }
        if (data.hasOwnProperty('scope')) {
          obj['scope'] = _ApiClient["default"].convertToType(data['scope'], 'String');
        }
        if (data.hasOwnProperty('expires_at')) {
          obj['expires_at'] = _ApiClient["default"].convertToType(data['expires_at'], 'String');
        }
        if (data.hasOwnProperty('created_at')) {
          obj['created_at'] = _ApiClient["default"].convertToType(data['created_at'], 'String');
        }
        if (data.hasOwnProperty('deleted_at')) {
          obj['deleted_at'] = _ApiClient["default"].convertToType(data['deleted_at'], 'Date');
        }
        if (data.hasOwnProperty('updated_at')) {
          obj['updated_at'] = _ApiClient["default"].convertToType(data['updated_at'], 'Date');
        }
        if (data.hasOwnProperty('id')) {
          obj['id'] = _ReadOnlyId["default"].constructFromObject(data['id']);
        }
        if (data.hasOwnProperty('customer_id')) {
          obj['customer_id'] = _ReadOnlyCustomerId["default"].constructFromObject(data['customer_id']);
        }
        if (data.hasOwnProperty('ip')) {
          obj['ip'] = _ApiClient["default"].convertToType(data['ip'], 'String');
        }
        if (data.hasOwnProperty('user_agent')) {
          obj['user_agent'] = _ApiClient["default"].convertToType(data['user_agent'], 'String');
        }
        if (data.hasOwnProperty('sudo_expires_at')) {
          obj['sudo_expires_at'] = _ApiClient["default"].convertToType(data['sudo_expires_at'], 'String');
        }
        if (data.hasOwnProperty('last_used_at')) {
          obj['last_used_at'] = _ApiClient["default"].convertToType(data['last_used_at'], 'Date');
        }
      }
      return obj;
    }
  }]);
  return AutomationTokenResponse;
}();
/**
 * The name of the token.
 * @member {String} name
 */
AutomationTokenResponse.prototype['name'] = undefined;

/**
 * @member {String} role
 */
AutomationTokenResponse.prototype['role'] = undefined;

/**
 * (Optional) The service IDs of the services the token will have access to. Separate service IDs with a space. If no services are specified, the token will have access to all services on the account. 
 * @member {Array.<String>} services
 */
AutomationTokenResponse.prototype['services'] = undefined;

/**
 * A space-delimited list of authorization scope.
 * @member {module:model/AutomationTokenResponse.ScopeEnum} scope
 * @default 'global'
 */
AutomationTokenResponse.prototype['scope'] = undefined;

/**
 * (optional) A UTC time-stamp of when the token will expire.
 * @member {String} expires_at
 */
AutomationTokenResponse.prototype['expires_at'] = undefined;

/**
 * A UTC time-stamp of when the token was created.
 * @member {String} created_at
 */
AutomationTokenResponse.prototype['created_at'] = undefined;

/**
 * Date and time in ISO 8601 format.
 * @member {Date} deleted_at
 */
AutomationTokenResponse.prototype['deleted_at'] = undefined;

/**
 * Date and time in ISO 8601 format.
 * @member {Date} updated_at
 */
AutomationTokenResponse.prototype['updated_at'] = undefined;

/**
 * @member {module:model/ReadOnlyId} id
 */
AutomationTokenResponse.prototype['id'] = undefined;

/**
 * @member {module:model/ReadOnlyCustomerId} customer_id
 */
AutomationTokenResponse.prototype['customer_id'] = undefined;

/**
 * The IP address of the client that last used the token.
 * @member {String} ip
 */
AutomationTokenResponse.prototype['ip'] = undefined;

/**
 * The User-Agent header of the client that last used the token.
 * @member {String} user_agent
 */
AutomationTokenResponse.prototype['user_agent'] = undefined;

/**
 * @member {String} sudo_expires_at
 */
AutomationTokenResponse.prototype['sudo_expires_at'] = undefined;

/**
 * A UTC time-stamp of when the token was last used.
 * @member {Date} last_used_at
 */
AutomationTokenResponse.prototype['last_used_at'] = undefined;

// Implement AutomationToken interface:
/**
 * The name of the token.
 * @member {String} name
 */
_AutomationToken["default"].prototype['name'] = undefined;
/**
 * The role on the token.
 * @member {module:model/AutomationToken.RoleEnum} role
 */
_AutomationToken["default"].prototype['role'] = undefined;
/**
 * (Optional) The service IDs of the services the token will have access to. Separate service IDs with a space. If no services are specified, the token will have access to all services on the account. 
 * @member {Array.<String>} services
 */
_AutomationToken["default"].prototype['services'] = undefined;
/**
 * A space-delimited list of authorization scope.
 * @member {module:model/AutomationToken.ScopeEnum} scope
 * @default 'global'
 */
_AutomationToken["default"].prototype['scope'] = undefined;
/**
 * A UTC time-stamp of when the token expires.
 * @member {String} expires_at
 */
_AutomationToken["default"].prototype['expires_at'] = undefined;
// Implement Timestamps interface:
/**
 * Date and time in ISO 8601 format.
 * @member {Date} created_at
 */
_Timestamps["default"].prototype['created_at'] = undefined;
/**
 * Date and time in ISO 8601 format.
 * @member {Date} deleted_at
 */
_Timestamps["default"].prototype['deleted_at'] = undefined;
/**
 * Date and time in ISO 8601 format.
 * @member {Date} updated_at
 */
_Timestamps["default"].prototype['updated_at'] = undefined;
// Implement AutomationTokenResponseAllOf interface:
/**
 * @member {module:model/ReadOnlyId} id
 */
_AutomationTokenResponseAllOf["default"].prototype['id'] = undefined;
/**
 * @member {module:model/ReadOnlyCustomerId} customer_id
 */
_AutomationTokenResponseAllOf["default"].prototype['customer_id'] = undefined;
/**
 * @member {String} role
 */
_AutomationTokenResponseAllOf["default"].prototype['role'] = undefined;
/**
 * The IP address of the client that last used the token.
 * @member {String} ip
 */
_AutomationTokenResponseAllOf["default"].prototype['ip'] = undefined;
/**
 * The User-Agent header of the client that last used the token.
 * @member {String} user_agent
 */
_AutomationTokenResponseAllOf["default"].prototype['user_agent'] = undefined;
/**
 * @member {String} sudo_expires_at
 */
_AutomationTokenResponseAllOf["default"].prototype['sudo_expires_at'] = undefined;
/**
 * A UTC time-stamp of when the token was last used.
 * @member {Date} last_used_at
 */
_AutomationTokenResponseAllOf["default"].prototype['last_used_at'] = undefined;
/**
 * A UTC time-stamp of when the token was created.
 * @member {String} created_at
 */
_AutomationTokenResponseAllOf["default"].prototype['created_at'] = undefined;
/**
 * (optional) A UTC time-stamp of when the token will expire.
 * @member {String} expires_at
 */
_AutomationTokenResponseAllOf["default"].prototype['expires_at'] = undefined;

/**
 * Allowed values for the <code>scope</code> property.
 * @enum {String}
 * @readonly
 */
AutomationTokenResponse['ScopeEnum'] = {
  /**
   * value: "global"
   * @const
   */
  "global": "global",
  /**
   * value: "purge_select"
   * @const
   */
  "purge_select": "purge_select",
  /**
   * value: "purge_all"
   * @const
   */
  "purge_all": "purge_all",
  /**
   * value: "global:read"
   * @const
   */
  "global:read": "global:read"
};
var _default = AutomationTokenResponse;
exports["default"] = _default;