"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _BillingAddressAttributes = _interopRequireDefault(require("./BillingAddressAttributes"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The BillingAddressVerificationErrorResponseErrors model module.
 * @module model/BillingAddressVerificationErrorResponseErrors
 * @version 7.4.0
 */
var BillingAddressVerificationErrorResponseErrors = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>BillingAddressVerificationErrorResponseErrors</code>.
   * @alias module:model/BillingAddressVerificationErrorResponseErrors
   * @param type {String} The error type.
   * @param title {String} 
   * @param detail {String} 
   * @param status {Number} 
   */
  function BillingAddressVerificationErrorResponseErrors(type, title, detail, status) {
    _classCallCheck(this, BillingAddressVerificationErrorResponseErrors);
    BillingAddressVerificationErrorResponseErrors.initialize(this, type, title, detail, status);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(BillingAddressVerificationErrorResponseErrors, null, [{
    key: "initialize",
    value: function initialize(obj, type, title, detail, status) {
      obj['type'] = type;
      obj['title'] = title;
      obj['detail'] = detail;
      obj['status'] = status;
    }

    /**
     * Constructs a <code>BillingAddressVerificationErrorResponseErrors</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/BillingAddressVerificationErrorResponseErrors} obj Optional instance to populate.
     * @return {module:model/BillingAddressVerificationErrorResponseErrors} The populated <code>BillingAddressVerificationErrorResponseErrors</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new BillingAddressVerificationErrorResponseErrors();
        if (data.hasOwnProperty('type')) {
          obj['type'] = _ApiClient["default"].convertToType(data['type'], 'String');
        }
        if (data.hasOwnProperty('title')) {
          obj['title'] = _ApiClient["default"].convertToType(data['title'], 'String');
        }
        if (data.hasOwnProperty('detail')) {
          obj['detail'] = _ApiClient["default"].convertToType(data['detail'], 'String');
        }
        if (data.hasOwnProperty('status')) {
          obj['status'] = _ApiClient["default"].convertToType(data['status'], 'Number');
        }
        if (data.hasOwnProperty('candidates')) {
          obj['candidates'] = _ApiClient["default"].convertToType(data['candidates'], [_BillingAddressAttributes["default"]]);
        }
      }
      return obj;
    }
  }]);
  return BillingAddressVerificationErrorResponseErrors;
}();
/**
 * The error type.
 * @member {String} type
 */
BillingAddressVerificationErrorResponseErrors.prototype['type'] = undefined;

/**
 * @member {String} title
 */
BillingAddressVerificationErrorResponseErrors.prototype['title'] = undefined;

/**
 * @member {String} detail
 */
BillingAddressVerificationErrorResponseErrors.prototype['detail'] = undefined;

/**
 * @member {Number} status
 */
BillingAddressVerificationErrorResponseErrors.prototype['status'] = undefined;

/**
 * @member {Array.<module:model/BillingAddressAttributes>} candidates
 */
BillingAddressVerificationErrorResponseErrors.prototype['candidates'] = undefined;
var _default = BillingAddressVerificationErrorResponseErrors;
exports["default"] = _default;