"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _Billing = _interopRequireDefault(require("./Billing"));
var _BillingEstimateLines = _interopRequireDefault(require("./BillingEstimateLines"));
var _BillingEstimateLinesLineItems = _interopRequireDefault(require("./BillingEstimateLinesLineItems"));
var _BillingStatus = _interopRequireDefault(require("./BillingStatus"));
var _BillingTotal = _interopRequireDefault(require("./BillingTotal"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The BillingEstimateResponse model module.
 * @module model/BillingEstimateResponse
 * @version 7.4.0
 */
var BillingEstimateResponse = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>BillingEstimateResponse</code>.
   * @alias module:model/BillingEstimateResponse
   * @implements module:model/Billing
   * @implements module:model/BillingEstimateLines
   */
  function BillingEstimateResponse() {
    _classCallCheck(this, BillingEstimateResponse);
    _Billing["default"].initialize(this);
    _BillingEstimateLines["default"].initialize(this);
    BillingEstimateResponse.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(BillingEstimateResponse, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>BillingEstimateResponse</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/BillingEstimateResponse} obj Optional instance to populate.
     * @return {module:model/BillingEstimateResponse} The populated <code>BillingEstimateResponse</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new BillingEstimateResponse();
        _Billing["default"].constructFromObject(data, obj);
        _BillingEstimateLines["default"].constructFromObject(data, obj);
        if (data.hasOwnProperty('end_time')) {
          obj['end_time'] = _ApiClient["default"].convertToType(data['end_time'], 'Date');
        }
        if (data.hasOwnProperty('start_time')) {
          obj['start_time'] = _ApiClient["default"].convertToType(data['start_time'], 'Date');
        }
        if (data.hasOwnProperty('invoice_id')) {
          obj['invoice_id'] = _ApiClient["default"].convertToType(data['invoice_id'], 'String');
        }
        if (data.hasOwnProperty('customer_id')) {
          obj['customer_id'] = _ApiClient["default"].convertToType(data['customer_id'], 'String');
        }
        if (data.hasOwnProperty('vendor_state')) {
          obj['vendor_state'] = _ApiClient["default"].convertToType(data['vendor_state'], 'String');
        }
        if (data.hasOwnProperty('status')) {
          obj['status'] = _BillingStatus["default"].constructFromObject(data['status']);
        }
        if (data.hasOwnProperty('total')) {
          obj['total'] = _BillingTotal["default"].constructFromObject(data['total']);
        }
        if (data.hasOwnProperty('regions')) {
          obj['regions'] = _ApiClient["default"].convertToType(data['regions'], {
            'String': {
              'String': Object
            }
          });
        }
        if (data.hasOwnProperty('line_items')) {
          obj['line_items'] = _ApiClient["default"].convertToType(data['line_items'], [_BillingEstimateLinesLineItems["default"]]);
        }
      }
      return obj;
    }
  }]);
  return BillingEstimateResponse;
}();
/**
 * Date and time in ISO 8601 format.
 * @member {Date} end_time
 */
BillingEstimateResponse.prototype['end_time'] = undefined;

/**
 * Date and time in ISO 8601 format.
 * @member {Date} start_time
 */
BillingEstimateResponse.prototype['start_time'] = undefined;

/**
 * @member {String} invoice_id
 */
BillingEstimateResponse.prototype['invoice_id'] = undefined;

/**
 * @member {String} customer_id
 */
BillingEstimateResponse.prototype['customer_id'] = undefined;

/**
 * The current state of our third-party billing vendor. One of `up` or `down`.
 * @member {String} vendor_state
 */
BillingEstimateResponse.prototype['vendor_state'] = undefined;

/**
 * @member {module:model/BillingStatus} status
 */
BillingEstimateResponse.prototype['status'] = undefined;

/**
 * @member {module:model/BillingTotal} total
 */
BillingEstimateResponse.prototype['total'] = undefined;

/**
 * Breakdown of regional data for products that are region based.
 * @member {Object.<String, Object.<String, Object>>} regions
 */
BillingEstimateResponse.prototype['regions'] = undefined;

/**
 * @member {Array.<module:model/BillingEstimateLinesLineItems>} line_items
 */
BillingEstimateResponse.prototype['line_items'] = undefined;

// Implement Billing interface:
/**
 * Date and time in ISO 8601 format.
 * @member {Date} end_time
 */
_Billing["default"].prototype['end_time'] = undefined;
/**
 * Date and time in ISO 8601 format.
 * @member {Date} start_time
 */
_Billing["default"].prototype['start_time'] = undefined;
/**
 * @member {String} invoice_id
 */
_Billing["default"].prototype['invoice_id'] = undefined;
/**
 * @member {String} customer_id
 */
_Billing["default"].prototype['customer_id'] = undefined;
/**
 * The current state of our third-party billing vendor. One of `up` or `down`.
 * @member {String} vendor_state
 */
_Billing["default"].prototype['vendor_state'] = undefined;
/**
 * @member {module:model/BillingStatus} status
 */
_Billing["default"].prototype['status'] = undefined;
/**
 * @member {module:model/BillingTotal} total
 */
_Billing["default"].prototype['total'] = undefined;
/**
 * Breakdown of regional data for products that are region based.
 * @member {Object.<String, Object.<String, Object>>} regions
 */
_Billing["default"].prototype['regions'] = undefined;
// Implement BillingEstimateLines interface:
/**
 * @member {Array.<module:model/BillingEstimateLinesLineItems>} line_items
 */
_BillingEstimateLines["default"].prototype['line_items'] = undefined;
var _default = BillingEstimateResponse;
exports["default"] = _default;