"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _LineItemData = _interopRequireDefault(require("./LineItemData"));
var _LineItemDataReadOnlyInvoiceId = _interopRequireDefault(require("./LineItemDataReadOnlyInvoiceId"));
var _Timestamps = _interopRequireDefault(require("./Timestamps"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The BillingResponseLineItem model module.
 * @module model/BillingResponseLineItem
 * @version 7.4.0
 */
var BillingResponseLineItem = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>BillingResponseLineItem</code>.
   * @alias module:model/BillingResponseLineItem
   * @implements module:model/Timestamps
   * @implements module:model/LineItemData
   */
  function BillingResponseLineItem() {
    _classCallCheck(this, BillingResponseLineItem);
    _Timestamps["default"].initialize(this);
    _LineItemData["default"].initialize(this);
    BillingResponseLineItem.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(BillingResponseLineItem, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>BillingResponseLineItem</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/BillingResponseLineItem} obj Optional instance to populate.
     * @return {module:model/BillingResponseLineItem} The populated <code>BillingResponseLineItem</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new BillingResponseLineItem();
        _Timestamps["default"].constructFromObject(data, obj);
        _LineItemData["default"].constructFromObject(data, obj);
        if (data.hasOwnProperty('created_at')) {
          obj['created_at'] = _ApiClient["default"].convertToType(data['created_at'], 'Date');
        }
        if (data.hasOwnProperty('deleted_at')) {
          obj['deleted_at'] = _ApiClient["default"].convertToType(data['deleted_at'], 'Date');
        }
        if (data.hasOwnProperty('updated_at')) {
          obj['updated_at'] = _ApiClient["default"].convertToType(data['updated_at'], 'Date');
        }
        if (data.hasOwnProperty('amount')) {
          obj['amount'] = _ApiClient["default"].convertToType(data['amount'], 'Number');
        }
        if (data.hasOwnProperty('aria_invoice_id')) {
          obj['aria_invoice_id'] = _LineItemDataReadOnlyInvoiceId["default"].constructFromObject(data['aria_invoice_id']);
        }
        if (data.hasOwnProperty('client_service_id')) {
          obj['client_service_id'] = _ApiClient["default"].convertToType(data['client_service_id'], 'String');
        }
        if (data.hasOwnProperty('credit_coupon_code')) {
          obj['credit_coupon_code'] = _ApiClient["default"].convertToType(data['credit_coupon_code'], 'String');
        }
        if (data.hasOwnProperty('description')) {
          obj['description'] = _ApiClient["default"].convertToType(data['description'], 'String');
        }
        if (data.hasOwnProperty('id')) {
          obj['id'] = _ApiClient["default"].convertToType(data['id'], 'String');
        }
        if (data.hasOwnProperty('line_number')) {
          obj['line_number'] = _ApiClient["default"].convertToType(data['line_number'], 'Number');
        }
        if (data.hasOwnProperty('plan_name')) {
          obj['plan_name'] = _ApiClient["default"].convertToType(data['plan_name'], 'String');
        }
        if (data.hasOwnProperty('plan_no')) {
          obj['plan_no'] = _ApiClient["default"].convertToType(data['plan_no'], 'Number');
        }
        if (data.hasOwnProperty('rate_per_unit')) {
          obj['rate_per_unit'] = _ApiClient["default"].convertToType(data['rate_per_unit'], 'Number');
        }
        if (data.hasOwnProperty('rate_schedule_no')) {
          obj['rate_schedule_no'] = _ApiClient["default"].convertToType(data['rate_schedule_no'], 'Number');
        }
        if (data.hasOwnProperty('rate_schedule_tier_no')) {
          obj['rate_schedule_tier_no'] = _ApiClient["default"].convertToType(data['rate_schedule_tier_no'], 'Number');
        }
        if (data.hasOwnProperty('service_name')) {
          obj['service_name'] = _ApiClient["default"].convertToType(data['service_name'], 'String');
        }
        if (data.hasOwnProperty('service_no')) {
          obj['service_no'] = _ApiClient["default"].convertToType(data['service_no'], 'Number');
        }
        if (data.hasOwnProperty('units')) {
          obj['units'] = _ApiClient["default"].convertToType(data['units'], 'Number');
        }
        if (data.hasOwnProperty('usage_type_cd')) {
          obj['usage_type_cd'] = _ApiClient["default"].convertToType(data['usage_type_cd'], 'String');
        }
        if (data.hasOwnProperty('usage_type_no')) {
          obj['usage_type_no'] = _ApiClient["default"].convertToType(data['usage_type_no'], 'Number');
        }
      }
      return obj;
    }
  }]);
  return BillingResponseLineItem;
}();
/**
 * Date and time in ISO 8601 format.
 * @member {Date} created_at
 */
BillingResponseLineItem.prototype['created_at'] = undefined;

/**
 * Date and time in ISO 8601 format.
 * @member {Date} deleted_at
 */
BillingResponseLineItem.prototype['deleted_at'] = undefined;

/**
 * Date and time in ISO 8601 format.
 * @member {Date} updated_at
 */
BillingResponseLineItem.prototype['updated_at'] = undefined;

/**
 * @member {Number} amount
 */
BillingResponseLineItem.prototype['amount'] = undefined;

/**
 * @member {module:model/LineItemDataReadOnlyInvoiceId} aria_invoice_id
 */
BillingResponseLineItem.prototype['aria_invoice_id'] = undefined;

/**
 * @member {String} client_service_id
 */
BillingResponseLineItem.prototype['client_service_id'] = undefined;

/**
 * @member {String} credit_coupon_code
 */
BillingResponseLineItem.prototype['credit_coupon_code'] = undefined;

/**
 * @member {String} description
 */
BillingResponseLineItem.prototype['description'] = undefined;

/**
 * @member {String} id
 */
BillingResponseLineItem.prototype['id'] = undefined;

/**
 * @member {Number} line_number
 */
BillingResponseLineItem.prototype['line_number'] = undefined;

/**
 * @member {String} plan_name
 */
BillingResponseLineItem.prototype['plan_name'] = undefined;

/**
 * @member {Number} plan_no
 */
BillingResponseLineItem.prototype['plan_no'] = undefined;

/**
 * @member {Number} rate_per_unit
 */
BillingResponseLineItem.prototype['rate_per_unit'] = undefined;

/**
 * @member {Number} rate_schedule_no
 */
BillingResponseLineItem.prototype['rate_schedule_no'] = undefined;

/**
 * @member {Number} rate_schedule_tier_no
 */
BillingResponseLineItem.prototype['rate_schedule_tier_no'] = undefined;

/**
 * @member {String} service_name
 */
BillingResponseLineItem.prototype['service_name'] = undefined;

/**
 * @member {Number} service_no
 */
BillingResponseLineItem.prototype['service_no'] = undefined;

/**
 * @member {Number} units
 */
BillingResponseLineItem.prototype['units'] = undefined;

/**
 * @member {String} usage_type_cd
 */
BillingResponseLineItem.prototype['usage_type_cd'] = undefined;

/**
 * @member {Number} usage_type_no
 */
BillingResponseLineItem.prototype['usage_type_no'] = undefined;

// Implement Timestamps interface:
/**
 * Date and time in ISO 8601 format.
 * @member {Date} created_at
 */
_Timestamps["default"].prototype['created_at'] = undefined;
/**
 * Date and time in ISO 8601 format.
 * @member {Date} deleted_at
 */
_Timestamps["default"].prototype['deleted_at'] = undefined;
/**
 * Date and time in ISO 8601 format.
 * @member {Date} updated_at
 */
_Timestamps["default"].prototype['updated_at'] = undefined;
// Implement LineItemData interface:
/**
 * @member {Number} amount
 */
_LineItemData["default"].prototype['amount'] = undefined;
/**
 * @member {module:model/LineItemDataReadOnlyInvoiceId} aria_invoice_id
 */
_LineItemData["default"].prototype['aria_invoice_id'] = undefined;
/**
 * @member {String} client_service_id
 */
_LineItemData["default"].prototype['client_service_id'] = undefined;
/**
 * @member {String} credit_coupon_code
 */
_LineItemData["default"].prototype['credit_coupon_code'] = undefined;
/**
 * @member {String} description
 */
_LineItemData["default"].prototype['description'] = undefined;
/**
 * @member {String} id
 */
_LineItemData["default"].prototype['id'] = undefined;
/**
 * @member {Number} line_number
 */
_LineItemData["default"].prototype['line_number'] = undefined;
/**
 * @member {String} plan_name
 */
_LineItemData["default"].prototype['plan_name'] = undefined;
/**
 * @member {Number} plan_no
 */
_LineItemData["default"].prototype['plan_no'] = undefined;
/**
 * @member {Number} rate_per_unit
 */
_LineItemData["default"].prototype['rate_per_unit'] = undefined;
/**
 * @member {Number} rate_schedule_no
 */
_LineItemData["default"].prototype['rate_schedule_no'] = undefined;
/**
 * @member {Number} rate_schedule_tier_no
 */
_LineItemData["default"].prototype['rate_schedule_tier_no'] = undefined;
/**
 * @member {String} service_name
 */
_LineItemData["default"].prototype['service_name'] = undefined;
/**
 * @member {Number} service_no
 */
_LineItemData["default"].prototype['service_no'] = undefined;
/**
 * @member {Number} units
 */
_LineItemData["default"].prototype['units'] = undefined;
/**
 * @member {String} usage_type_cd
 */
_LineItemData["default"].prototype['usage_type_cd'] = undefined;
/**
 * @member {Number} usage_type_no
 */
_LineItemData["default"].prototype['usage_type_no'] = undefined;
var _default = BillingResponseLineItem;
exports["default"] = _default;