"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _BulkUpdateConfigStoreItemAllOf = _interopRequireDefault(require("./BulkUpdateConfigStoreItemAllOf"));
var _ConfigStoreItem = _interopRequireDefault(require("./ConfigStoreItem"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The BulkUpdateConfigStoreItem model module.
 * @module model/BulkUpdateConfigStoreItem
 * @version 7.4.0
 */
var BulkUpdateConfigStoreItem = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>BulkUpdateConfigStoreItem</code>.
   * @alias module:model/BulkUpdateConfigStoreItem
   * @implements module:model/ConfigStoreItem
   * @implements module:model/BulkUpdateConfigStoreItemAllOf
   */
  function BulkUpdateConfigStoreItem() {
    _classCallCheck(this, BulkUpdateConfigStoreItem);
    _ConfigStoreItem["default"].initialize(this);
    _BulkUpdateConfigStoreItemAllOf["default"].initialize(this);
    BulkUpdateConfigStoreItem.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(BulkUpdateConfigStoreItem, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>BulkUpdateConfigStoreItem</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/BulkUpdateConfigStoreItem} obj Optional instance to populate.
     * @return {module:model/BulkUpdateConfigStoreItem} The populated <code>BulkUpdateConfigStoreItem</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new BulkUpdateConfigStoreItem();
        _ConfigStoreItem["default"].constructFromObject(data, obj);
        _BulkUpdateConfigStoreItemAllOf["default"].constructFromObject(data, obj);
        if (data.hasOwnProperty('item_key')) {
          obj['item_key'] = _ApiClient["default"].convertToType(data['item_key'], 'String');
        }
        if (data.hasOwnProperty('item_value')) {
          obj['item_value'] = _ApiClient["default"].convertToType(data['item_value'], 'String');
        }
        if (data.hasOwnProperty('op')) {
          obj['op'] = _ApiClient["default"].convertToType(data['op'], 'String');
        }
      }
      return obj;
    }
  }]);
  return BulkUpdateConfigStoreItem;
}();
/**
 * Item key, maximum 256 characters.
 * @member {String} item_key
 */
BulkUpdateConfigStoreItem.prototype['item_key'] = undefined;

/**
 * Item value, maximum 8000 characters.
 * @member {String} item_value
 */
BulkUpdateConfigStoreItem.prototype['item_value'] = undefined;

/**
 * @member {module:model/BulkUpdateConfigStoreItem.OpEnum} op
 */
BulkUpdateConfigStoreItem.prototype['op'] = undefined;

// Implement ConfigStoreItem interface:
/**
 * Item key, maximum 256 characters.
 * @member {String} item_key
 */
_ConfigStoreItem["default"].prototype['item_key'] = undefined;
/**
 * Item value, maximum 8000 characters.
 * @member {String} item_value
 */
_ConfigStoreItem["default"].prototype['item_value'] = undefined;
// Implement BulkUpdateConfigStoreItemAllOf interface:
/**
 * @member {module:model/BulkUpdateConfigStoreItemAllOf.OpEnum} op
 */
_BulkUpdateConfigStoreItemAllOf["default"].prototype['op'] = undefined;

/**
 * Allowed values for the <code>op</code> property.
 * @enum {String}
 * @readonly
 */
BulkUpdateConfigStoreItem['OpEnum'] = {
  /**
   * value: "create"
   * @const
   */
  "create": "create",
  /**
   * value: "update"
   * @const
   */
  "update": "update",
  /**
   * value: "delete"
   * @const
   */
  "delete": "delete",
  /**
   * value: "upsert"
   * @const
   */
  "upsert": "upsert"
};
var _default = BulkUpdateConfigStoreItem;
exports["default"] = _default;