"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The DefaultSettings model module.
 * @module model/DefaultSettings
 * @version 7.4.0
 */
var DefaultSettings = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>DefaultSettings</code>.
   * @alias module:model/DefaultSettings
   */
  function DefaultSettings() {
    _classCallCheck(this, DefaultSettings);
    DefaultSettings.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(DefaultSettings, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>DefaultSettings</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/DefaultSettings} obj Optional instance to populate.
     * @return {module:model/DefaultSettings} The populated <code>DefaultSettings</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new DefaultSettings();
        if (data.hasOwnProperty('resize_filter')) {
          obj['resize_filter'] = _ApiClient["default"].convertToType(data['resize_filter'], 'String');
        }
        if (data.hasOwnProperty('webp')) {
          obj['webp'] = _ApiClient["default"].convertToType(data['webp'], 'Boolean');
        }
        if (data.hasOwnProperty('webp_quality')) {
          obj['webp_quality'] = _ApiClient["default"].convertToType(data['webp_quality'], 'Number');
        }
        if (data.hasOwnProperty('jpeg_type')) {
          obj['jpeg_type'] = _ApiClient["default"].convertToType(data['jpeg_type'], 'String');
        }
        if (data.hasOwnProperty('jpeg_quality')) {
          obj['jpeg_quality'] = _ApiClient["default"].convertToType(data['jpeg_quality'], 'Number');
        }
        if (data.hasOwnProperty('upscale')) {
          obj['upscale'] = _ApiClient["default"].convertToType(data['upscale'], 'Boolean');
        }
        if (data.hasOwnProperty('allow_video')) {
          obj['allow_video'] = _ApiClient["default"].convertToType(data['allow_video'], 'Boolean');
        }
      }
      return obj;
    }
  }]);
  return DefaultSettings;
}();
/**
 * The type of filter to use while resizing an image.
 * @member {module:model/DefaultSettings.ResizeFilterEnum} resize_filter
 * @default 'lanczos3'
 */
DefaultSettings.prototype['resize_filter'] = undefined;

/**
 * Controls whether or not to default to WebP output when the client supports it. This is equivalent to adding \"auto=webp\" to all image optimizer requests. 
 * @member {Boolean} webp
 * @default false
 */
DefaultSettings.prototype['webp'] = false;

/**
 * The default quality to use with WebP output. This can be overridden with the second option in the \"quality\" URL parameter on specific image optimizer requests. 
 * @member {Number} webp_quality
 * @default 85
 */
DefaultSettings.prototype['webp_quality'] = 85;

/**
 * The default type of JPEG output to use. This can be overridden with \"format=bjpeg\" and \"format=pjpeg\" on specific image optimizer requests. 
 * @member {module:model/DefaultSettings.JpegTypeEnum} jpeg_type
 * @default 'auto'
 */
DefaultSettings.prototype['jpeg_type'] = undefined;

/**
 * The default quality to use with JPEG output. This can be overridden with the \"quality\" parameter on specific image optimizer requests. 
 * @member {Number} jpeg_quality
 * @default 85
 */
DefaultSettings.prototype['jpeg_quality'] = 85;

/**
 * Whether or not we should allow output images to render at sizes larger than input. 
 * @member {Boolean} upscale
 * @default false
 */
DefaultSettings.prototype['upscale'] = false;

/**
 * Enables GIF to MP4 transformations on this service.
 * @member {Boolean} allow_video
 * @default false
 */
DefaultSettings.prototype['allow_video'] = false;

/**
 * Allowed values for the <code>resize_filter</code> property.
 * @enum {String}
 * @readonly
 */
DefaultSettings['ResizeFilterEnum'] = {
  /**
   * value: "lanczos3"
   * @const
   */
  "lanczos3": "lanczos3",
  /**
   * value: "lanczos2"
   * @const
   */
  "lanczos2": "lanczos2",
  /**
   * value: "bicubic"
   * @const
   */
  "bicubic": "bicubic",
  /**
   * value: "bilinear"
   * @const
   */
  "bilinear": "bilinear",
  /**
   * value: "nearest"
   * @const
   */
  "nearest": "nearest"
};

/**
 * Allowed values for the <code>jpeg_type</code> property.
 * @enum {String}
 * @readonly
 */
DefaultSettings['JpegTypeEnum'] = {
  /**
   * value: "auto"
   * @const
   */
  "auto": "auto",
  /**
   * value: "baseline"
   * @const
   */
  "baseline": "baseline",
  /**
   * value: "progressive"
   * @const
   */
  "progressive": "progressive"
};
var _default = DefaultSettings;
exports["default"] = _default;