"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _DomainInspectorRealtimeEntry = _interopRequireDefault(require("./DomainInspectorRealtimeEntry"));
var _SubsequentRequestTimestamp = _interopRequireDefault(require("./SubsequentRequestTimestamp"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The DomainInspector model module.
 * @module model/DomainInspector
 * @version 7.4.0
 */
var DomainInspector = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>DomainInspector</code>.
   * @alias module:model/DomainInspector
   */
  function DomainInspector() {
    _classCallCheck(this, DomainInspector);
    DomainInspector.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(DomainInspector, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>DomainInspector</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/DomainInspector} obj Optional instance to populate.
     * @return {module:model/DomainInspector} The populated <code>DomainInspector</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new DomainInspector();
        if (data.hasOwnProperty('Timestamp')) {
          obj['Timestamp'] = _SubsequentRequestTimestamp["default"].constructFromObject(data['Timestamp']);
        }
        if (data.hasOwnProperty('AggregateDelay')) {
          obj['AggregateDelay'] = _ApiClient["default"].convertToType(data['AggregateDelay'], 'Number');
        }
        if (data.hasOwnProperty('Data')) {
          obj['Data'] = _ApiClient["default"].convertToType(data['Data'], [_DomainInspectorRealtimeEntry["default"]]);
        }
      }
      return obj;
    }
  }]);
  return DomainInspector;
}();
/**
 * @member {module:model/SubsequentRequestTimestamp} Timestamp
 */
DomainInspector.prototype['Timestamp'] = undefined;

/**
 * Offset of entry timestamps from the current time due to processing time.
 * @member {Number} AggregateDelay
 */
DomainInspector.prototype['AggregateDelay'] = undefined;

/**
 * A list of report [entries](#entry-data-model), each representing one second of time.
 * @member {Array.<module:model/DomainInspectorRealtimeEntry>} Data
 */
DomainInspector.prototype['Data'] = undefined;
var _default = DomainInspector;
exports["default"] = _default;