"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _Historical = _interopRequireDefault(require("./Historical"));
var _HistoricalMeta = _interopRequireDefault(require("./HistoricalMeta"));
var _HistoricalUsageData = _interopRequireDefault(require("./HistoricalUsageData"));
var _HistoricalUsageServiceResponseAllOf = _interopRequireDefault(require("./HistoricalUsageServiceResponseAllOf"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The HistoricalUsageServiceResponse model module.
 * @module model/HistoricalUsageServiceResponse
 * @version 7.4.0
 */
var HistoricalUsageServiceResponse = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>HistoricalUsageServiceResponse</code>.
   * @alias module:model/HistoricalUsageServiceResponse
   * @implements module:model/Historical
   * @implements module:model/HistoricalUsageServiceResponseAllOf
   */
  function HistoricalUsageServiceResponse() {
    _classCallCheck(this, HistoricalUsageServiceResponse);
    _Historical["default"].initialize(this);
    _HistoricalUsageServiceResponseAllOf["default"].initialize(this);
    HistoricalUsageServiceResponse.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(HistoricalUsageServiceResponse, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>HistoricalUsageServiceResponse</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/HistoricalUsageServiceResponse} obj Optional instance to populate.
     * @return {module:model/HistoricalUsageServiceResponse} The populated <code>HistoricalUsageServiceResponse</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new HistoricalUsageServiceResponse();
        _Historical["default"].constructFromObject(data, obj);
        _HistoricalUsageServiceResponseAllOf["default"].constructFromObject(data, obj);
        if (data.hasOwnProperty('status')) {
          obj['status'] = _ApiClient["default"].convertToType(data['status'], 'String');
        }
        if (data.hasOwnProperty('meta')) {
          obj['meta'] = _HistoricalMeta["default"].constructFromObject(data['meta']);
        }
        if (data.hasOwnProperty('msg')) {
          obj['msg'] = _ApiClient["default"].convertToType(data['msg'], 'String');
        }
        if (data.hasOwnProperty('data')) {
          obj['data'] = _ApiClient["default"].convertToType(data['data'], {
            'String': {
              'String': _HistoricalUsageData["default"]
            }
          });
        }
      }
      return obj;
    }
  }]);
  return HistoricalUsageServiceResponse;
}();
/**
 * Whether or not we were able to successfully execute the query.
 * @member {String} status
 */
HistoricalUsageServiceResponse.prototype['status'] = undefined;

/**
 * @member {module:model/HistoricalMeta} meta
 */
HistoricalUsageServiceResponse.prototype['meta'] = undefined;

/**
 * If the query was not successful, this will provide a string that explains why.
 * @member {String} msg
 */
HistoricalUsageServiceResponse.prototype['msg'] = undefined;

/**
 * Organized by *region*.
 * @member {Object.<String, Object.<String, module:model/HistoricalUsageData>>} data
 */
HistoricalUsageServiceResponse.prototype['data'] = undefined;

// Implement Historical interface:
/**
 * Whether or not we were able to successfully execute the query.
 * @member {String} status
 */
_Historical["default"].prototype['status'] = undefined;
/**
 * @member {module:model/HistoricalMeta} meta
 */
_Historical["default"].prototype['meta'] = undefined;
/**
 * If the query was not successful, this will provide a string that explains why.
 * @member {String} msg
 */
_Historical["default"].prototype['msg'] = undefined;
// Implement HistoricalUsageServiceResponseAllOf interface:
/**
 * Organized by *region*.
 * @member {Object.<String, Object.<String, module:model/HistoricalUsageData>>} data
 */
_HistoricalUsageServiceResponseAllOf["default"].prototype['data'] = undefined;
var _default = HistoricalUsageServiceResponse;
exports["default"] = _default;