"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The IamPermission model module.
 * @module model/IamPermission
 * @version 7.4.0
 */
var IamPermission = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>IamPermission</code>.
   * @alias module:model/IamPermission
   */
  function IamPermission() {
    _classCallCheck(this, IamPermission);
    IamPermission.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(IamPermission, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>IamPermission</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/IamPermission} obj Optional instance to populate.
     * @return {module:model/IamPermission} The populated <code>IamPermission</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new IamPermission();
        if (data.hasOwnProperty('id')) {
          obj['id'] = _ApiClient["default"].convertToType(data['id'], 'String');
        }
        if (data.hasOwnProperty('object')) {
          obj['object'] = _ApiClient["default"].convertToType(data['object'], 'String');
        }
        if (data.hasOwnProperty('name')) {
          obj['name'] = _ApiClient["default"].convertToType(data['name'], 'String');
        }
        if (data.hasOwnProperty('description')) {
          obj['description'] = _ApiClient["default"].convertToType(data['description'], 'String');
        }
        if (data.hasOwnProperty('resource_name')) {
          obj['resource_name'] = _ApiClient["default"].convertToType(data['resource_name'], 'String');
        }
        if (data.hasOwnProperty('resource_description')) {
          obj['resource_description'] = _ApiClient["default"].convertToType(data['resource_description'], 'String');
        }
        if (data.hasOwnProperty('scope')) {
          obj['scope'] = _ApiClient["default"].convertToType(data['scope'], 'String');
        }
      }
      return obj;
    }
  }]);
  return IamPermission;
}();
/**
 * Alphanumeric string identifying the permission.
 * @member {String} id
 */
IamPermission.prototype['id'] = undefined;

/**
 * The type of the object.
 * @member {String} object
 */
IamPermission.prototype['object'] = undefined;

/**
 * Name of the permission.
 * @member {String} name
 */
IamPermission.prototype['name'] = undefined;

/**
 * The description of the permission.
 * @member {String} description
 */
IamPermission.prototype['description'] = undefined;

/**
 * The name of the resource the operation will be performed on.
 * @member {String} resource_name
 */
IamPermission.prototype['resource_name'] = undefined;

/**
 * The description of the resource.
 * @member {String} resource_description
 */
IamPermission.prototype['resource_description'] = undefined;

/**
 * Permissions are either \"service\" level or \"account\" level.
 * @member {String} scope
 */
IamPermission.prototype['scope'] = undefined;
var _default = IamPermission;
exports["default"] = _default;