"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _InvitationData = _interopRequireDefault(require("./InvitationData"));
var _InvitationResponseDataAllOf = _interopRequireDefault(require("./InvitationResponseDataAllOf"));
var _RelationshipsForInvitation = _interopRequireDefault(require("./RelationshipsForInvitation"));
var _Timestamps = _interopRequireDefault(require("./Timestamps"));
var _TypeInvitation = _interopRequireDefault(require("./TypeInvitation"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The InvitationResponseData model module.
 * @module model/InvitationResponseData
 * @version 7.4.0
 */
var InvitationResponseData = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>InvitationResponseData</code>.
   * @alias module:model/InvitationResponseData
   * @implements module:model/InvitationData
   * @implements module:model/InvitationResponseDataAllOf
   */
  function InvitationResponseData() {
    _classCallCheck(this, InvitationResponseData);
    _InvitationData["default"].initialize(this);
    _InvitationResponseDataAllOf["default"].initialize(this);
    InvitationResponseData.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(InvitationResponseData, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>InvitationResponseData</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/InvitationResponseData} obj Optional instance to populate.
     * @return {module:model/InvitationResponseData} The populated <code>InvitationResponseData</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new InvitationResponseData();
        _InvitationData["default"].constructFromObject(data, obj);
        _InvitationResponseDataAllOf["default"].constructFromObject(data, obj);
        if (data.hasOwnProperty('type')) {
          obj['type'] = _TypeInvitation["default"].constructFromObject(data['type']);
        }
        if (data.hasOwnProperty('attributes')) {
          obj['attributes'] = _Timestamps["default"].constructFromObject(data['attributes']);
        }
        if (data.hasOwnProperty('relationships')) {
          obj['relationships'] = _RelationshipsForInvitation["default"].constructFromObject(data['relationships']);
        }
        if (data.hasOwnProperty('id')) {
          obj['id'] = _ApiClient["default"].convertToType(data['id'], 'String');
        }
      }
      return obj;
    }
  }]);
  return InvitationResponseData;
}();
/**
 * @member {module:model/TypeInvitation} type
 */
InvitationResponseData.prototype['type'] = undefined;

/**
 * @member {module:model/Timestamps} attributes
 */
InvitationResponseData.prototype['attributes'] = undefined;

/**
 * @member {module:model/RelationshipsForInvitation} relationships
 */
InvitationResponseData.prototype['relationships'] = undefined;

/**
 * @member {String} id
 */
InvitationResponseData.prototype['id'] = undefined;

// Implement InvitationData interface:
/**
 * @member {module:model/TypeInvitation} type
 */
_InvitationData["default"].prototype['type'] = undefined;
/**
 * @member {module:model/InvitationDataAttributes} attributes
 */
_InvitationData["default"].prototype['attributes'] = undefined;
/**
 * @member {module:model/RelationshipServiceInvitationsCreate} relationships
 */
_InvitationData["default"].prototype['relationships'] = undefined;
// Implement InvitationResponseDataAllOf interface:
/**
 * @member {String} id
 */
_InvitationResponseDataAllOf["default"].prototype['id'] = undefined;
/**
 * @member {module:model/Timestamps} attributes
 */
_InvitationResponseDataAllOf["default"].prototype['attributes'] = undefined;
/**
 * @member {module:model/RelationshipsForInvitation} relationships
 */
_InvitationResponseDataAllOf["default"].prototype['relationships'] = undefined;
var _default = InvitationResponseData;
exports["default"] = _default;