"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _Invoice = _interopRequireDefault(require("./Invoice"));
var _Invoicelineitems = _interopRequireDefault(require("./Invoicelineitems"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The InvoiceResponse model module.
 * @module model/InvoiceResponse
 * @version 7.4.0
 */
var InvoiceResponse = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>InvoiceResponse</code>.
   * @alias module:model/InvoiceResponse
   * @implements module:model/Invoice
   */
  function InvoiceResponse() {
    _classCallCheck(this, InvoiceResponse);
    _Invoice["default"].initialize(this);
    InvoiceResponse.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(InvoiceResponse, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>InvoiceResponse</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/InvoiceResponse} obj Optional instance to populate.
     * @return {module:model/InvoiceResponse} The populated <code>InvoiceResponse</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new InvoiceResponse();
        _Invoice["default"].constructFromObject(data, obj);
        if (data.hasOwnProperty('customer_id')) {
          obj['customer_id'] = _ApiClient["default"].convertToType(data['customer_id'], 'String');
        }
        if (data.hasOwnProperty('invoice_id')) {
          obj['invoice_id'] = _ApiClient["default"].convertToType(data['invoice_id'], 'String');
        }
        if (data.hasOwnProperty('invoice_posted_on')) {
          obj['invoice_posted_on'] = _ApiClient["default"].convertToType(data['invoice_posted_on'], 'Date');
        }
        if (data.hasOwnProperty('billing_start_date')) {
          obj['billing_start_date'] = _ApiClient["default"].convertToType(data['billing_start_date'], 'Date');
        }
        if (data.hasOwnProperty('billing_end_date')) {
          obj['billing_end_date'] = _ApiClient["default"].convertToType(data['billing_end_date'], 'Date');
        }
        if (data.hasOwnProperty('statement_number')) {
          obj['statement_number'] = _ApiClient["default"].convertToType(data['statement_number'], 'String');
        }
        if (data.hasOwnProperty('currency_code')) {
          obj['currency_code'] = _ApiClient["default"].convertToType(data['currency_code'], 'String');
        }
        if (data.hasOwnProperty('monthly_transaction_amount')) {
          obj['monthly_transaction_amount'] = _ApiClient["default"].convertToType(data['monthly_transaction_amount'], 'Number');
        }
        if (data.hasOwnProperty('transaction_line_items')) {
          obj['transaction_line_items'] = _ApiClient["default"].convertToType(data['transaction_line_items'], [_Invoicelineitems["default"]]);
        }
      }
      return obj;
    }
  }]);
  return InvoiceResponse;
}();
/**
 * Customer ID associated with the invoice.
 * @member {String} customer_id
 */
InvoiceResponse.prototype['customer_id'] = undefined;

/**
 * Alphanumeric string identifying the invoice.
 * @member {String} invoice_id
 */
InvoiceResponse.prototype['invoice_id'] = undefined;

/**
 * Date and time invoice was posted on, in ISO 8601 format.
 * @member {Date} invoice_posted_on
 */
InvoiceResponse.prototype['invoice_posted_on'] = undefined;

/**
 * Date and time (in ISO 8601 format) for initiation point of a billing cycle, signifying the start of charges for a service or subscription.
 * @member {Date} billing_start_date
 */
InvoiceResponse.prototype['billing_start_date'] = undefined;

/**
 * Date and time (in ISO 8601 format) for termination point of a billing cycle, signifying the end of charges for a service or subscription.
 * @member {Date} billing_end_date
 */
InvoiceResponse.prototype['billing_end_date'] = undefined;

/**
 * Alphanumeric string identifying the statement number.
 * @member {String} statement_number
 */
InvoiceResponse.prototype['statement_number'] = undefined;

/**
 * Three-letter code representing a specific currency used for financial transactions.
 * @member {String} currency_code
 */
InvoiceResponse.prototype['currency_code'] = undefined;

/**
 * Total billable amount for invoiced services charged within a single month.
 * @member {Number} monthly_transaction_amount
 */
InvoiceResponse.prototype['monthly_transaction_amount'] = undefined;

/**
 * @member {Array.<module:model/Invoicelineitems>} transaction_line_items
 */
InvoiceResponse.prototype['transaction_line_items'] = undefined;

// Implement Invoice interface:
/**
 * Customer ID associated with the invoice.
 * @member {String} customer_id
 */
_Invoice["default"].prototype['customer_id'] = undefined;
/**
 * Alphanumeric string identifying the invoice.
 * @member {String} invoice_id
 */
_Invoice["default"].prototype['invoice_id'] = undefined;
/**
 * Date and time invoice was posted on, in ISO 8601 format.
 * @member {Date} invoice_posted_on
 */
_Invoice["default"].prototype['invoice_posted_on'] = undefined;
/**
 * Date and time (in ISO 8601 format) for initiation point of a billing cycle, signifying the start of charges for a service or subscription.
 * @member {Date} billing_start_date
 */
_Invoice["default"].prototype['billing_start_date'] = undefined;
/**
 * Date and time (in ISO 8601 format) for termination point of a billing cycle, signifying the end of charges for a service or subscription.
 * @member {Date} billing_end_date
 */
_Invoice["default"].prototype['billing_end_date'] = undefined;
/**
 * Alphanumeric string identifying the statement number.
 * @member {String} statement_number
 */
_Invoice["default"].prototype['statement_number'] = undefined;
/**
 * Three-letter code representing a specific currency used for financial transactions.
 * @member {String} currency_code
 */
_Invoice["default"].prototype['currency_code'] = undefined;
/**
 * Total billable amount for invoiced services charged within a single month.
 * @member {Number} monthly_transaction_amount
 */
_Invoice["default"].prototype['monthly_transaction_amount'] = undefined;
/**
 * @member {Array.<module:model/Invoicelineitems>} transaction_line_items
 */
_Invoice["default"].prototype['transaction_line_items'] = undefined;
var _default = InvoiceResponse;
exports["default"] = _default;