"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The Invoicelineitems model module.
 * @module model/Invoicelineitems
 * @version 7.4.0
 */
var Invoicelineitems = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>Invoicelineitems</code>.
   * @alias module:model/Invoicelineitems
   */
  function Invoicelineitems() {
    _classCallCheck(this, Invoicelineitems);
    Invoicelineitems.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(Invoicelineitems, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>Invoicelineitems</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/Invoicelineitems} obj Optional instance to populate.
     * @return {module:model/Invoicelineitems} The populated <code>Invoicelineitems</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new Invoicelineitems();
        if (data.hasOwnProperty('description')) {
          obj['description'] = _ApiClient["default"].convertToType(data['description'], 'String');
        }
        if (data.hasOwnProperty('amount')) {
          obj['amount'] = _ApiClient["default"].convertToType(data['amount'], 'Number');
        }
        if (data.hasOwnProperty('credit_coupon_code')) {
          obj['credit_coupon_code'] = _ApiClient["default"].convertToType(data['credit_coupon_code'], 'String');
        }
        if (data.hasOwnProperty('rate')) {
          obj['rate'] = _ApiClient["default"].convertToType(data['rate'], 'Number');
        }
        if (data.hasOwnProperty('units')) {
          obj['units'] = _ApiClient["default"].convertToType(data['units'], 'Number');
        }
        if (data.hasOwnProperty('ProductName')) {
          obj['ProductName'] = _ApiClient["default"].convertToType(data['ProductName'], 'String');
        }
        if (data.hasOwnProperty('ProductGroup')) {
          obj['ProductGroup'] = _ApiClient["default"].convertToType(data['ProductGroup'], 'String');
        }
        if (data.hasOwnProperty('ProductLine')) {
          obj['ProductLine'] = _ApiClient["default"].convertToType(data['ProductLine'], 'String');
        }
        if (data.hasOwnProperty('Region')) {
          obj['Region'] = _ApiClient["default"].convertToType(data['Region'], 'String');
        }
        if (data.hasOwnProperty('UsageType')) {
          obj['UsageType'] = _ApiClient["default"].convertToType(data['UsageType'], 'String');
        }
      }
      return obj;
    }
  }]);
  return Invoicelineitems;
}();
/**
 * Invoice line item transaction name.
 * @member {String} description
 */
Invoicelineitems.prototype['description'] = undefined;

/**
 * Billed amount for line item.
 * @member {Number} amount
 */
Invoicelineitems.prototype['amount'] = undefined;

/**
 * Discount coupon associated with the invoice for any account or service credits.
 * @member {String} credit_coupon_code
 */
Invoicelineitems.prototype['credit_coupon_code'] = undefined;

/**
 * Price per unit.
 * @member {Number} rate
 */
Invoicelineitems.prototype['rate'] = undefined;

/**
 * Total number of units of usage.
 * @member {Number} units
 */
Invoicelineitems.prototype['units'] = undefined;

/**
 * The name of the product.
 * @member {String} ProductName
 */
Invoicelineitems.prototype['ProductName'] = undefined;

/**
 * The broader classification of the product (e.g., `Compute` or `Full-Site Delivery`).
 * @member {String} ProductGroup
 */
Invoicelineitems.prototype['ProductGroup'] = undefined;

/**
 * The broader classification of the product (e.g., `Network Services` or `Security`).
 * @member {String} ProductLine
 */
Invoicelineitems.prototype['ProductLine'] = undefined;

/**
 * The geographical area applicable for regionally based products.
 * @member {String} Region
 */
Invoicelineitems.prototype['Region'] = undefined;

/**
 * The unit of measure (e.g., `requests` or `bandwidth`).
 * @member {String} UsageType
 */
Invoicelineitems.prototype['UsageType'] = undefined;
var _default = Invoicelineitems;
exports["default"] = _default;