"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The LegacyWafUpdateStatus model module.
 * @module model/LegacyWafUpdateStatus
 * @version 7.4.0
 */
var LegacyWafUpdateStatus = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>LegacyWafUpdateStatus</code>.
   * @alias module:model/LegacyWafUpdateStatus
   */
  function LegacyWafUpdateStatus() {
    _classCallCheck(this, LegacyWafUpdateStatus);
    LegacyWafUpdateStatus.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(LegacyWafUpdateStatus, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>LegacyWafUpdateStatus</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/LegacyWafUpdateStatus} obj Optional instance to populate.
     * @return {module:model/LegacyWafUpdateStatus} The populated <code>LegacyWafUpdateStatus</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new LegacyWafUpdateStatus();
        if (data.hasOwnProperty('completed_at')) {
          obj['completed_at'] = _ApiClient["default"].convertToType(data['completed_at'], 'String');
        }
        if (data.hasOwnProperty('created_at')) {
          obj['created_at'] = _ApiClient["default"].convertToType(data['created_at'], 'String');
        }
        if (data.hasOwnProperty('data')) {
          obj['data'] = _ApiClient["default"].convertToType(data['data'], 'String');
        }
        if (data.hasOwnProperty('message')) {
          obj['message'] = _ApiClient["default"].convertToType(data['message'], 'String');
        }
        if (data.hasOwnProperty('status')) {
          obj['status'] = _ApiClient["default"].convertToType(data['status'], 'String');
        }
        if (data.hasOwnProperty('updated_at')) {
          obj['updated_at'] = _ApiClient["default"].convertToType(data['updated_at'], 'String');
        }
      }
      return obj;
    }
  }]);
  return LegacyWafUpdateStatus;
}();
/**
 * Date and time that job was completed.
 * @member {String} completed_at
 */
LegacyWafUpdateStatus.prototype['completed_at'] = undefined;

/**
 * Date and time that job was created.
 * @member {String} created_at
 */
LegacyWafUpdateStatus.prototype['created_at'] = undefined;

/**
 * This field can contain data passed to the background worker as well as output from the background job.
 * @member {String} data
 */
LegacyWafUpdateStatus.prototype['data'] = undefined;

/**
 * Message with information about the status of the update.
 * @member {String} message
 */
LegacyWafUpdateStatus.prototype['message'] = undefined;

/**
 * Current status of the update.
 * @member {String} status
 */
LegacyWafUpdateStatus.prototype['status'] = undefined;

/**
 * Date and time that job was last updated.
 * @member {String} updated_at
 */
LegacyWafUpdateStatus.prototype['updated_at'] = undefined;
var _default = LegacyWafUpdateStatus;
exports["default"] = _default;