"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The MutualAuthenticationDataAttributes model module.
 * @module model/MutualAuthenticationDataAttributes
 * @version 7.4.0
 */
var MutualAuthenticationDataAttributes = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>MutualAuthenticationDataAttributes</code>.
   * @alias module:model/MutualAuthenticationDataAttributes
   */
  function MutualAuthenticationDataAttributes() {
    _classCallCheck(this, MutualAuthenticationDataAttributes);
    MutualAuthenticationDataAttributes.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(MutualAuthenticationDataAttributes, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>MutualAuthenticationDataAttributes</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/MutualAuthenticationDataAttributes} obj Optional instance to populate.
     * @return {module:model/MutualAuthenticationDataAttributes} The populated <code>MutualAuthenticationDataAttributes</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new MutualAuthenticationDataAttributes();
        if (data.hasOwnProperty('cert_bundle')) {
          obj['cert_bundle'] = _ApiClient["default"].convertToType(data['cert_bundle'], 'String');
        }
        if (data.hasOwnProperty('enforced')) {
          obj['enforced'] = _ApiClient["default"].convertToType(data['enforced'], 'Boolean');
        }
        if (data.hasOwnProperty('name')) {
          obj['name'] = _ApiClient["default"].convertToType(data['name'], 'String');
        }
      }
      return obj;
    }
  }]);
  return MutualAuthenticationDataAttributes;
}();
/**
 * One or more certificates. Enter each individual certificate blob on a new line. Must be PEM-formatted. Required on create. You may optionally rotate the cert_bundle on update.
 * @member {String} cert_bundle
 */
MutualAuthenticationDataAttributes.prototype['cert_bundle'] = undefined;

/**
 * Determines whether Mutual TLS will fail closed (enforced) or fail open. A true value will require a successful Mutual TLS handshake for the connection to continue and will fail closed if unsuccessful. A false value will fail open and allow the connection to proceed. Optional. Defaults to true.
 * @member {Boolean} enforced
 */
MutualAuthenticationDataAttributes.prototype['enforced'] = undefined;

/**
 * A custom name for your mutual authentication. Optional. If name is not supplied we will auto-generate one.
 * @member {String} name
 */
MutualAuthenticationDataAttributes.prototype['name'] = undefined;
var _default = MutualAuthenticationDataAttributes;
exports["default"] = _default;