"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _OriginInspectorHistoricalMetaFilters = _interopRequireDefault(require("./OriginInspectorHistoricalMetaFilters"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The OriginInspectorHistoricalMeta model module.
 * @module model/OriginInspectorHistoricalMeta
 * @version 7.4.0
 */
var OriginInspectorHistoricalMeta = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>OriginInspectorHistoricalMeta</code>.
   * Meta information about the scope of the query in a human readable format.
   * @alias module:model/OriginInspectorHistoricalMeta
   */
  function OriginInspectorHistoricalMeta() {
    _classCallCheck(this, OriginInspectorHistoricalMeta);
    OriginInspectorHistoricalMeta.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(OriginInspectorHistoricalMeta, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>OriginInspectorHistoricalMeta</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/OriginInspectorHistoricalMeta} obj Optional instance to populate.
     * @return {module:model/OriginInspectorHistoricalMeta} The populated <code>OriginInspectorHistoricalMeta</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new OriginInspectorHistoricalMeta();
        if (data.hasOwnProperty('start')) {
          obj['start'] = _ApiClient["default"].convertToType(data['start'], 'String');
        }
        if (data.hasOwnProperty('end')) {
          obj['end'] = _ApiClient["default"].convertToType(data['end'], 'String');
        }
        if (data.hasOwnProperty('downsample')) {
          obj['downsample'] = _ApiClient["default"].convertToType(data['downsample'], 'String');
        }
        if (data.hasOwnProperty('metrics')) {
          obj['metrics'] = _ApiClient["default"].convertToType(data['metrics'], 'String');
        }
        if (data.hasOwnProperty('limit')) {
          obj['limit'] = _ApiClient["default"].convertToType(data['limit'], 'Number');
        }
        if (data.hasOwnProperty('next_cursor')) {
          obj['next_cursor'] = _ApiClient["default"].convertToType(data['next_cursor'], 'String');
        }
        if (data.hasOwnProperty('sort')) {
          obj['sort'] = _ApiClient["default"].convertToType(data['sort'], 'String');
        }
        if (data.hasOwnProperty('group_by')) {
          obj['group_by'] = _ApiClient["default"].convertToType(data['group_by'], 'String');
        }
        if (data.hasOwnProperty('filters')) {
          obj['filters'] = _OriginInspectorHistoricalMetaFilters["default"].constructFromObject(data['filters']);
        }
      }
      return obj;
    }
  }]);
  return OriginInspectorHistoricalMeta;
}();
/**
 * Start time that was used to perform the query as an ISO-8601-formatted date and time.
 * @member {String} start
 */
OriginInspectorHistoricalMeta.prototype['start'] = undefined;

/**
 * End time that was used to perform the query as an ISO-8601-formatted date and time.
 * @member {String} end
 */
OriginInspectorHistoricalMeta.prototype['end'] = undefined;

/**
 * Downsample that was used to perform the query. One of `minute`, `hour` or `day`.
 * @member {String} downsample
 */
OriginInspectorHistoricalMeta.prototype['downsample'] = undefined;

/**
 * A comma-separated list of the metrics that were requested.
 * @member {String} metrics
 */
OriginInspectorHistoricalMeta.prototype['metrics'] = undefined;

/**
 * The maximum number of results shown per page.
 * @member {Number} limit
 */
OriginInspectorHistoricalMeta.prototype['limit'] = undefined;

/**
 * A string that can be used to request the next page of results, if any.
 * @member {String} next_cursor
 */
OriginInspectorHistoricalMeta.prototype['next_cursor'] = undefined;

/**
 * A comma-separated list of keys the results are sorted by.
 * @member {String} sort
 */
OriginInspectorHistoricalMeta.prototype['sort'] = undefined;

/**
 * A comma-separated list of dimensions being summed over in the query.
 * @member {String} group_by
 */
OriginInspectorHistoricalMeta.prototype['group_by'] = undefined;

/**
 * @member {module:model/OriginInspectorHistoricalMetaFilters} filters
 */
OriginInspectorHistoricalMeta.prototype['filters'] = undefined;
var _default = OriginInspectorHistoricalMeta;
exports["default"] = _default;