"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _OriginInspectorMeasurements = _interopRequireDefault(require("./OriginInspectorMeasurements"));
var _OriginInspectorRealtimeEntryRecorded = _interopRequireDefault(require("./OriginInspectorRealtimeEntryRecorded"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The OriginInspectorRealtimeEntry model module.
 * @module model/OriginInspectorRealtimeEntry
 * @version 7.4.0
 */
var OriginInspectorRealtimeEntry = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>OriginInspectorRealtimeEntry</code>.
   * Each reporting period is represented by an entry in the &#x60;Data&#x60; property of the top level response and provides access to [measurement data](#measurements-data-model) for that time period, grouped by origin name and optionally by POP. The &#x60;datacenter&#x60; property organizes the measurements by Fastly POP, while the &#x60;aggregated&#x60; property combines the measurements of all POPs. 
   * @alias module:model/OriginInspectorRealtimeEntry
   */
  function OriginInspectorRealtimeEntry() {
    _classCallCheck(this, OriginInspectorRealtimeEntry);
    OriginInspectorRealtimeEntry.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(OriginInspectorRealtimeEntry, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>OriginInspectorRealtimeEntry</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/OriginInspectorRealtimeEntry} obj Optional instance to populate.
     * @return {module:model/OriginInspectorRealtimeEntry} The populated <code>OriginInspectorRealtimeEntry</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new OriginInspectorRealtimeEntry();
        if (data.hasOwnProperty('recorded')) {
          obj['recorded'] = _OriginInspectorRealtimeEntryRecorded["default"].constructFromObject(data['recorded']);
        }
        if (data.hasOwnProperty('aggregated')) {
          obj['aggregated'] = _ApiClient["default"].convertToType(data['aggregated'], {
            'String': _OriginInspectorMeasurements["default"]
          });
        }
        if (data.hasOwnProperty('datacenter')) {
          obj['datacenter'] = _ApiClient["default"].convertToType(data['datacenter'], {
            'String': {
              'String': _OriginInspectorMeasurements["default"]
            }
          });
        }
      }
      return obj;
    }
  }]);
  return OriginInspectorRealtimeEntry;
}();
/**
 * @member {module:model/OriginInspectorRealtimeEntryRecorded} recorded
 */
OriginInspectorRealtimeEntry.prototype['recorded'] = undefined;

/**
 * Groups [measurements](#measurements-data-model) by backend name.
 * @member {Object.<String, module:model/OriginInspectorMeasurements>} aggregated
 */
OriginInspectorRealtimeEntry.prototype['aggregated'] = undefined;

/**
 * Groups [measurements](#measurements-data-model) by POP, then backend name. See the [POPs API](https://www.fastly.com/documentation/reference/api/utils/pops/) for details about POP identifiers.
 * @member {Object.<String, Object.<String, module:model/OriginInspectorMeasurements>>} datacenter
 */
OriginInspectorRealtimeEntry.prototype['datacenter'] = undefined;
var _default = OriginInspectorRealtimeEntry;
exports["default"] = _default;