"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The PackageMetadata model module.
 * @module model/PackageMetadata
 * @version 7.4.0
 */
var PackageMetadata = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>PackageMetadata</code>.
   * [Package metadata](#metadata-model) that has been extracted from the uploaded package. 
   * @alias module:model/PackageMetadata
   */
  function PackageMetadata() {
    _classCallCheck(this, PackageMetadata);
    PackageMetadata.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(PackageMetadata, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>PackageMetadata</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/PackageMetadata} obj Optional instance to populate.
     * @return {module:model/PackageMetadata} The populated <code>PackageMetadata</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new PackageMetadata();
        if (data.hasOwnProperty('name')) {
          obj['name'] = _ApiClient["default"].convertToType(data['name'], 'String');
        }
        if (data.hasOwnProperty('description')) {
          obj['description'] = _ApiClient["default"].convertToType(data['description'], 'String');
        }
        if (data.hasOwnProperty('authors')) {
          obj['authors'] = _ApiClient["default"].convertToType(data['authors'], ['String']);
        }
        if (data.hasOwnProperty('language')) {
          obj['language'] = _ApiClient["default"].convertToType(data['language'], 'String');
        }
        if (data.hasOwnProperty('size')) {
          obj['size'] = _ApiClient["default"].convertToType(data['size'], 'Number');
        }
        if (data.hasOwnProperty('hashsum')) {
          obj['hashsum'] = _ApiClient["default"].convertToType(data['hashsum'], 'String');
        }
        if (data.hasOwnProperty('files_hash')) {
          obj['files_hash'] = _ApiClient["default"].convertToType(data['files_hash'], 'String');
        }
      }
      return obj;
    }
  }]);
  return PackageMetadata;
}();
/**
 * Name of the Compute package.
 * @member {String} name
 */
PackageMetadata.prototype['name'] = undefined;

/**
 * Description of the Compute package.
 * @member {String} description
 */
PackageMetadata.prototype['description'] = undefined;

/**
 * A list of package authors' email addresses.
 * @member {Array.<String>} authors
 */
PackageMetadata.prototype['authors'] = undefined;

/**
 * The language of the Compute package.
 * @member {String} language
 */
PackageMetadata.prototype['language'] = undefined;

/**
 * Size of the Compute package in bytes.
 * @member {Number} size
 */
PackageMetadata.prototype['size'] = undefined;

/**
 * Hash of the Compute package.
 * @member {String} hashsum
 */
PackageMetadata.prototype['hashsum'] = undefined;

/**
 * Hash of the files within the Compute package.
 * @member {String} files_hash
 */
PackageMetadata.prototype['files_hash'] = undefined;
var _default = PackageMetadata;
exports["default"] = _default;