"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _RealtimeEntryAggregated = _interopRequireDefault(require("./RealtimeEntryAggregated"));
var _RealtimeEntryRecorded = _interopRequireDefault(require("./RealtimeEntryRecorded"));
var _RealtimeMeasurements = _interopRequireDefault(require("./RealtimeMeasurements"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The RealtimeEntry model module.
 * @module model/RealtimeEntry
 * @version 7.4.0
 */
var RealtimeEntry = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>RealtimeEntry</code>.
   * A list of records, each representing one second of time. The &#x60;Data&#x60; property provides access to [measurement data](#measurements-data-model) for that time period, grouped in various ways.
   * @alias module:model/RealtimeEntry
   */
  function RealtimeEntry() {
    _classCallCheck(this, RealtimeEntry);
    RealtimeEntry.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(RealtimeEntry, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>RealtimeEntry</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/RealtimeEntry} obj Optional instance to populate.
     * @return {module:model/RealtimeEntry} The populated <code>RealtimeEntry</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new RealtimeEntry();
        if (data.hasOwnProperty('recorded')) {
          obj['recorded'] = _RealtimeEntryRecorded["default"].constructFromObject(data['recorded']);
        }
        if (data.hasOwnProperty('aggregated')) {
          obj['aggregated'] = _RealtimeEntryAggregated["default"].constructFromObject(data['aggregated']);
        }
        if (data.hasOwnProperty('datacenter')) {
          obj['datacenter'] = _ApiClient["default"].convertToType(data['datacenter'], {
            'String': _RealtimeMeasurements["default"]
          });
        }
      }
      return obj;
    }
  }]);
  return RealtimeEntry;
}();
/**
 * @member {module:model/RealtimeEntryRecorded} recorded
 */
RealtimeEntry.prototype['recorded'] = undefined;

/**
 * @member {module:model/RealtimeEntryAggregated} aggregated
 */
RealtimeEntry.prototype['aggregated'] = undefined;

/**
 * Groups [measurements](#measurements-data-model) by POP. See the [POPs API](https://www.fastly.com/documentation/reference/api/utils/pops/) for details of POP identifiers.
 * @member {Object.<String, module:model/RealtimeMeasurements>} datacenter
 */
RealtimeEntry.prototype['datacenter'] = undefined;
var _default = RealtimeEntry;
exports["default"] = _default;