"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _RequestSettingsAdditional = _interopRequireDefault(require("./RequestSettingsAdditional"));
var _RequestSettingsResponseAllOf = _interopRequireDefault(require("./RequestSettingsResponseAllOf"));
var _ServiceIdAndVersionString = _interopRequireDefault(require("./ServiceIdAndVersionString"));
var _Timestamps = _interopRequireDefault(require("./Timestamps"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The RequestSettingsResponse model module.
 * @module model/RequestSettingsResponse
 * @version 7.4.0
 */
var RequestSettingsResponse = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>RequestSettingsResponse</code>.
   * @alias module:model/RequestSettingsResponse
   * @implements module:model/Timestamps
   * @implements module:model/ServiceIdAndVersionString
   * @implements module:model/RequestSettingsAdditional
   * @implements module:model/RequestSettingsResponseAllOf
   */
  function RequestSettingsResponse() {
    _classCallCheck(this, RequestSettingsResponse);
    _Timestamps["default"].initialize(this);
    _ServiceIdAndVersionString["default"].initialize(this);
    _RequestSettingsAdditional["default"].initialize(this);
    _RequestSettingsResponseAllOf["default"].initialize(this);
    RequestSettingsResponse.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(RequestSettingsResponse, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>RequestSettingsResponse</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/RequestSettingsResponse} obj Optional instance to populate.
     * @return {module:model/RequestSettingsResponse} The populated <code>RequestSettingsResponse</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new RequestSettingsResponse();
        _Timestamps["default"].constructFromObject(data, obj);
        _ServiceIdAndVersionString["default"].constructFromObject(data, obj);
        _RequestSettingsAdditional["default"].constructFromObject(data, obj);
        _RequestSettingsResponseAllOf["default"].constructFromObject(data, obj);
        if (data.hasOwnProperty('created_at')) {
          obj['created_at'] = _ApiClient["default"].convertToType(data['created_at'], 'Date');
        }
        if (data.hasOwnProperty('deleted_at')) {
          obj['deleted_at'] = _ApiClient["default"].convertToType(data['deleted_at'], 'Date');
        }
        if (data.hasOwnProperty('updated_at')) {
          obj['updated_at'] = _ApiClient["default"].convertToType(data['updated_at'], 'Date');
        }
        if (data.hasOwnProperty('service_id')) {
          obj['service_id'] = _ApiClient["default"].convertToType(data['service_id'], 'String');
        }
        if (data.hasOwnProperty('version')) {
          obj['version'] = _ApiClient["default"].convertToType(data['version'], 'String');
        }
        if (data.hasOwnProperty('action')) {
          obj['action'] = _ApiClient["default"].convertToType(data['action'], 'String');
        }
        if (data.hasOwnProperty('default_host')) {
          obj['default_host'] = _ApiClient["default"].convertToType(data['default_host'], 'String');
        }
        if (data.hasOwnProperty('hash_keys')) {
          obj['hash_keys'] = _ApiClient["default"].convertToType(data['hash_keys'], 'String');
        }
        if (data.hasOwnProperty('name')) {
          obj['name'] = _ApiClient["default"].convertToType(data['name'], 'String');
        }
        if (data.hasOwnProperty('request_condition')) {
          obj['request_condition'] = _ApiClient["default"].convertToType(data['request_condition'], 'String');
        }
        if (data.hasOwnProperty('xff')) {
          obj['xff'] = _ApiClient["default"].convertToType(data['xff'], 'String');
        }
        if (data.hasOwnProperty('bypass_busy_wait')) {
          obj['bypass_busy_wait'] = _ApiClient["default"].convertToType(data['bypass_busy_wait'], 'String');
        }
        if (data.hasOwnProperty('force_miss')) {
          obj['force_miss'] = _ApiClient["default"].convertToType(data['force_miss'], 'String');
        }
        if (data.hasOwnProperty('force_ssl')) {
          obj['force_ssl'] = _ApiClient["default"].convertToType(data['force_ssl'], 'String');
        }
        if (data.hasOwnProperty('geo_headers')) {
          obj['geo_headers'] = _ApiClient["default"].convertToType(data['geo_headers'], 'String');
        }
        if (data.hasOwnProperty('max_stale_age')) {
          obj['max_stale_age'] = _ApiClient["default"].convertToType(data['max_stale_age'], 'String');
        }
        if (data.hasOwnProperty('timer_support')) {
          obj['timer_support'] = _ApiClient["default"].convertToType(data['timer_support'], 'String');
        }
      }
      return obj;
    }
  }]);
  return RequestSettingsResponse;
}();
/**
 * Date and time in ISO 8601 format.
 * @member {Date} created_at
 */
RequestSettingsResponse.prototype['created_at'] = undefined;

/**
 * Date and time in ISO 8601 format.
 * @member {Date} deleted_at
 */
RequestSettingsResponse.prototype['deleted_at'] = undefined;

/**
 * Date and time in ISO 8601 format.
 * @member {Date} updated_at
 */
RequestSettingsResponse.prototype['updated_at'] = undefined;

/**
 * @member {String} service_id
 */
RequestSettingsResponse.prototype['service_id'] = undefined;

/**
 * @member {String} version
 */
RequestSettingsResponse.prototype['version'] = undefined;

/**
 * Allows you to terminate request handling and immediately perform an action.
 * @member {module:model/RequestSettingsResponse.ActionEnum} action
 */
RequestSettingsResponse.prototype['action'] = undefined;

/**
 * Sets the host header.
 * @member {String} default_host
 */
RequestSettingsResponse.prototype['default_host'] = undefined;

/**
 * Comma separated list of varnish request object fields that should be in the hash key.
 * @member {String} hash_keys
 */
RequestSettingsResponse.prototype['hash_keys'] = undefined;

/**
 * Name for the request settings.
 * @member {String} name
 */
RequestSettingsResponse.prototype['name'] = undefined;

/**
 * Condition which, if met, will select this configuration during a request. Optional.
 * @member {String} request_condition
 */
RequestSettingsResponse.prototype['request_condition'] = undefined;

/**
 * Short for X-Forwarded-For.
 * @member {module:model/RequestSettingsResponse.XffEnum} xff
 */
RequestSettingsResponse.prototype['xff'] = undefined;

/**
 * Disable collapsed forwarding, so you don't wait for other objects to origin.
 * @member {String} bypass_busy_wait
 */
RequestSettingsResponse.prototype['bypass_busy_wait'] = undefined;

/**
 * Allows you to force a cache miss for the request. Replaces the item in the cache if the content is cacheable.
 * @member {String} force_miss
 */
RequestSettingsResponse.prototype['force_miss'] = undefined;

/**
 * Forces the request use SSL (redirects a non-SSL to SSL).
 * @member {String} force_ssl
 */
RequestSettingsResponse.prototype['force_ssl'] = undefined;

/**
 * Injects Fastly-Geo-Country, Fastly-Geo-City, and Fastly-Geo-Region into the request headers.
 * @member {String} geo_headers
 */
RequestSettingsResponse.prototype['geo_headers'] = undefined;

/**
 * How old an object is allowed to be to serve stale-if-error or stale-while-revalidate.
 * @member {String} max_stale_age
 */
RequestSettingsResponse.prototype['max_stale_age'] = undefined;

/**
 * Injects the X-Timer info into the request for viewing origin fetch durations.
 * @member {String} timer_support
 */
RequestSettingsResponse.prototype['timer_support'] = undefined;

// Implement Timestamps interface:
/**
 * Date and time in ISO 8601 format.
 * @member {Date} created_at
 */
_Timestamps["default"].prototype['created_at'] = undefined;
/**
 * Date and time in ISO 8601 format.
 * @member {Date} deleted_at
 */
_Timestamps["default"].prototype['deleted_at'] = undefined;
/**
 * Date and time in ISO 8601 format.
 * @member {Date} updated_at
 */
_Timestamps["default"].prototype['updated_at'] = undefined;
// Implement ServiceIdAndVersionString interface:
/**
 * @member {String} service_id
 */
_ServiceIdAndVersionString["default"].prototype['service_id'] = undefined;
/**
 * @member {String} version
 */
_ServiceIdAndVersionString["default"].prototype['version'] = undefined;
// Implement RequestSettingsAdditional interface:
/**
 * Allows you to terminate request handling and immediately perform an action.
 * @member {module:model/RequestSettingsAdditional.ActionEnum} action
 */
_RequestSettingsAdditional["default"].prototype['action'] = undefined;
/**
 * Sets the host header.
 * @member {String} default_host
 */
_RequestSettingsAdditional["default"].prototype['default_host'] = undefined;
/**
 * Comma separated list of varnish request object fields that should be in the hash key.
 * @member {String} hash_keys
 */
_RequestSettingsAdditional["default"].prototype['hash_keys'] = undefined;
/**
 * Name for the request settings.
 * @member {String} name
 */
_RequestSettingsAdditional["default"].prototype['name'] = undefined;
/**
 * Condition which, if met, will select this configuration during a request. Optional.
 * @member {String} request_condition
 */
_RequestSettingsAdditional["default"].prototype['request_condition'] = undefined;
/**
 * Short for X-Forwarded-For.
 * @member {module:model/RequestSettingsAdditional.XffEnum} xff
 */
_RequestSettingsAdditional["default"].prototype['xff'] = undefined;
// Implement RequestSettingsResponseAllOf interface:
/**
 * Disable collapsed forwarding, so you don't wait for other objects to origin.
 * @member {String} bypass_busy_wait
 */
_RequestSettingsResponseAllOf["default"].prototype['bypass_busy_wait'] = undefined;
/**
 * Allows you to force a cache miss for the request. Replaces the item in the cache if the content is cacheable.
 * @member {String} force_miss
 */
_RequestSettingsResponseAllOf["default"].prototype['force_miss'] = undefined;
/**
 * Forces the request use SSL (redirects a non-SSL to SSL).
 * @member {String} force_ssl
 */
_RequestSettingsResponseAllOf["default"].prototype['force_ssl'] = undefined;
/**
 * Injects Fastly-Geo-Country, Fastly-Geo-City, and Fastly-Geo-Region into the request headers.
 * @member {String} geo_headers
 */
_RequestSettingsResponseAllOf["default"].prototype['geo_headers'] = undefined;
/**
 * How old an object is allowed to be to serve stale-if-error or stale-while-revalidate.
 * @member {String} max_stale_age
 */
_RequestSettingsResponseAllOf["default"].prototype['max_stale_age'] = undefined;
/**
 * Injects the X-Timer info into the request for viewing origin fetch durations.
 * @member {String} timer_support
 */
_RequestSettingsResponseAllOf["default"].prototype['timer_support'] = undefined;

/**
 * Allowed values for the <code>action</code> property.
 * @enum {String}
 * @readonly
 */
RequestSettingsResponse['ActionEnum'] = {
  /**
   * value: "lookup"
   * @const
   */
  "lookup": "lookup",
  /**
   * value: "pass"
   * @const
   */
  "pass": "pass"
};

/**
 * Allowed values for the <code>xff</code> property.
 * @enum {String}
 * @readonly
 */
RequestSettingsResponse['XffEnum'] = {
  /**
   * value: "clear"
   * @const
   */
  "clear": "clear",
  /**
   * value: "leave"
   * @const
   */
  "leave": "leave",
  /**
   * value: "append"
   * @const
   */
  "append": "append",
  /**
   * value: "append_all"
   * @const
   */
  "append_all": "append_all",
  /**
   * value: "overwrite"
   * @const
   */
  "overwrite": "overwrite"
};
var _default = RequestSettingsResponse;
exports["default"] = _default;