"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _ServiceAuthorizationData = _interopRequireDefault(require("./ServiceAuthorizationData"));
var _ServiceAuthorizationDataRelationships = _interopRequireDefault(require("./ServiceAuthorizationDataRelationships"));
var _ServiceAuthorizationResponseDataAllOf = _interopRequireDefault(require("./ServiceAuthorizationResponseDataAllOf"));
var _Timestamps = _interopRequireDefault(require("./Timestamps"));
var _TypeServiceAuthorization = _interopRequireDefault(require("./TypeServiceAuthorization"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The ServiceAuthorizationResponseData model module.
 * @module model/ServiceAuthorizationResponseData
 * @version 7.4.0
 */
var ServiceAuthorizationResponseData = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>ServiceAuthorizationResponseData</code>.
   * @alias module:model/ServiceAuthorizationResponseData
   * @implements module:model/ServiceAuthorizationData
   * @implements module:model/ServiceAuthorizationResponseDataAllOf
   */
  function ServiceAuthorizationResponseData() {
    _classCallCheck(this, ServiceAuthorizationResponseData);
    _ServiceAuthorizationData["default"].initialize(this);
    _ServiceAuthorizationResponseDataAllOf["default"].initialize(this);
    ServiceAuthorizationResponseData.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(ServiceAuthorizationResponseData, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>ServiceAuthorizationResponseData</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/ServiceAuthorizationResponseData} obj Optional instance to populate.
     * @return {module:model/ServiceAuthorizationResponseData} The populated <code>ServiceAuthorizationResponseData</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new ServiceAuthorizationResponseData();
        _ServiceAuthorizationData["default"].constructFromObject(data, obj);
        _ServiceAuthorizationResponseDataAllOf["default"].constructFromObject(data, obj);
        if (data.hasOwnProperty('type')) {
          obj['type'] = _TypeServiceAuthorization["default"].constructFromObject(data['type']);
        }
        if (data.hasOwnProperty('attributes')) {
          obj['attributes'] = _Timestamps["default"].constructFromObject(data['attributes']);
        }
        if (data.hasOwnProperty('relationships')) {
          obj['relationships'] = _ServiceAuthorizationDataRelationships["default"].constructFromObject(data['relationships']);
        }
        if (data.hasOwnProperty('id')) {
          obj['id'] = _ApiClient["default"].convertToType(data['id'], 'String');
        }
      }
      return obj;
    }
  }]);
  return ServiceAuthorizationResponseData;
}();
/**
 * @member {module:model/TypeServiceAuthorization} type
 */
ServiceAuthorizationResponseData.prototype['type'] = undefined;

/**
 * @member {module:model/Timestamps} attributes
 */
ServiceAuthorizationResponseData.prototype['attributes'] = undefined;

/**
 * @member {module:model/ServiceAuthorizationDataRelationships} relationships
 */
ServiceAuthorizationResponseData.prototype['relationships'] = undefined;

/**
 * @member {String} id
 */
ServiceAuthorizationResponseData.prototype['id'] = undefined;

// Implement ServiceAuthorizationData interface:
/**
 * @member {module:model/TypeServiceAuthorization} type
 */
_ServiceAuthorizationData["default"].prototype['type'] = undefined;
/**
 * @member {module:model/ServiceAuthorizationDataAttributes} attributes
 */
_ServiceAuthorizationData["default"].prototype['attributes'] = undefined;
/**
 * @member {module:model/ServiceAuthorizationDataRelationships} relationships
 */
_ServiceAuthorizationData["default"].prototype['relationships'] = undefined;
// Implement ServiceAuthorizationResponseDataAllOf interface:
/**
 * @member {String} id
 */
_ServiceAuthorizationResponseDataAllOf["default"].prototype['id'] = undefined;
/**
 * @member {module:model/Timestamps} attributes
 */
_ServiceAuthorizationResponseDataAllOf["default"].prototype['attributes'] = undefined;
var _default = ServiceAuthorizationResponseData;
exports["default"] = _default;