"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _BackendResponse = _interopRequireDefault(require("./BackendResponse"));
var _CacheSettingResponse = _interopRequireDefault(require("./CacheSettingResponse"));
var _ConditionResponse = _interopRequireDefault(require("./ConditionResponse"));
var _Director = _interopRequireDefault(require("./Director"));
var _DomainResponse = _interopRequireDefault(require("./DomainResponse"));
var _GzipResponse = _interopRequireDefault(require("./GzipResponse"));
var _HeaderResponse = _interopRequireDefault(require("./HeaderResponse"));
var _HealthcheckResponse = _interopRequireDefault(require("./HealthcheckResponse"));
var _RequestSettingsResponse = _interopRequireDefault(require("./RequestSettingsResponse"));
var _ResponseObjectResponse = _interopRequireDefault(require("./ResponseObjectResponse"));
var _SchemasSnippetResponse = _interopRequireDefault(require("./SchemasSnippetResponse"));
var _SchemasVclResponse = _interopRequireDefault(require("./SchemasVclResponse"));
var _SchemasVersionResponse = _interopRequireDefault(require("./SchemasVersionResponse"));
var _VersionDetail = _interopRequireDefault(require("./VersionDetail"));
var _VersionDetailSettings = _interopRequireDefault(require("./VersionDetailSettings"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The ServiceVersionDetail model module.
 * @module model/ServiceVersionDetail
 * @version 7.4.0
 */
var ServiceVersionDetail = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>ServiceVersionDetail</code>.
   * @alias module:model/ServiceVersionDetail
   * @implements module:model/SchemasVersionResponse
   * @implements module:model/VersionDetail
   */
  function ServiceVersionDetail() {
    _classCallCheck(this, ServiceVersionDetail);
    _SchemasVersionResponse["default"].initialize(this);
    _VersionDetail["default"].initialize(this);
    ServiceVersionDetail.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(ServiceVersionDetail, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>ServiceVersionDetail</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/ServiceVersionDetail} obj Optional instance to populate.
     * @return {module:model/ServiceVersionDetail} The populated <code>ServiceVersionDetail</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new ServiceVersionDetail();
        _SchemasVersionResponse["default"].constructFromObject(data, obj);
        _VersionDetail["default"].constructFromObject(data, obj);
        if (data.hasOwnProperty('active')) {
          obj['active'] = _ApiClient["default"].convertToType(data['active'], 'Boolean');
        }
        if (data.hasOwnProperty('comment')) {
          obj['comment'] = _ApiClient["default"].convertToType(data['comment'], 'String');
        }
        if (data.hasOwnProperty('deployed')) {
          obj['deployed'] = _ApiClient["default"].convertToType(data['deployed'], 'Boolean');
        }
        if (data.hasOwnProperty('locked')) {
          obj['locked'] = _ApiClient["default"].convertToType(data['locked'], 'Boolean');
        }
        if (data.hasOwnProperty('number')) {
          obj['number'] = _ApiClient["default"].convertToType(data['number'], 'Number');
        }
        if (data.hasOwnProperty('staging')) {
          obj['staging'] = _ApiClient["default"].convertToType(data['staging'], 'Boolean');
        }
        if (data.hasOwnProperty('testing')) {
          obj['testing'] = _ApiClient["default"].convertToType(data['testing'], 'Boolean');
        }
        if (data.hasOwnProperty('created_at')) {
          obj['created_at'] = _ApiClient["default"].convertToType(data['created_at'], 'Date');
        }
        if (data.hasOwnProperty('deleted_at')) {
          obj['deleted_at'] = _ApiClient["default"].convertToType(data['deleted_at'], 'Date');
        }
        if (data.hasOwnProperty('updated_at')) {
          obj['updated_at'] = _ApiClient["default"].convertToType(data['updated_at'], 'Date');
        }
        if (data.hasOwnProperty('service_id')) {
          obj['service_id'] = _ApiClient["default"].convertToType(data['service_id'], 'String');
        }
        if (data.hasOwnProperty('backends')) {
          obj['backends'] = _ApiClient["default"].convertToType(data['backends'], [_BackendResponse["default"]]);
        }
        if (data.hasOwnProperty('cache_settings')) {
          obj['cache_settings'] = _ApiClient["default"].convertToType(data['cache_settings'], [_CacheSettingResponse["default"]]);
        }
        if (data.hasOwnProperty('conditions')) {
          obj['conditions'] = _ApiClient["default"].convertToType(data['conditions'], [_ConditionResponse["default"]]);
        }
        if (data.hasOwnProperty('directors')) {
          obj['directors'] = _ApiClient["default"].convertToType(data['directors'], [_Director["default"]]);
        }
        if (data.hasOwnProperty('domains')) {
          obj['domains'] = _ApiClient["default"].convertToType(data['domains'], [_DomainResponse["default"]]);
        }
        if (data.hasOwnProperty('gzips')) {
          obj['gzips'] = _ApiClient["default"].convertToType(data['gzips'], [_GzipResponse["default"]]);
        }
        if (data.hasOwnProperty('headers')) {
          obj['headers'] = _ApiClient["default"].convertToType(data['headers'], [_HeaderResponse["default"]]);
        }
        if (data.hasOwnProperty('healthchecks')) {
          obj['healthchecks'] = _ApiClient["default"].convertToType(data['healthchecks'], [_HealthcheckResponse["default"]]);
        }
        if (data.hasOwnProperty('request_settings')) {
          obj['request_settings'] = _ApiClient["default"].convertToType(data['request_settings'], [_RequestSettingsResponse["default"]]);
        }
        if (data.hasOwnProperty('response_objects')) {
          obj['response_objects'] = _ApiClient["default"].convertToType(data['response_objects'], [_ResponseObjectResponse["default"]]);
        }
        if (data.hasOwnProperty('settings')) {
          obj['settings'] = _VersionDetailSettings["default"].constructFromObject(data['settings']);
        }
        if (data.hasOwnProperty('snippets')) {
          obj['snippets'] = _ApiClient["default"].convertToType(data['snippets'], [_SchemasSnippetResponse["default"]]);
        }
        if (data.hasOwnProperty('vcls')) {
          obj['vcls'] = _ApiClient["default"].convertToType(data['vcls'], [_SchemasVclResponse["default"]]);
        }
        if (data.hasOwnProperty('wordpress')) {
          obj['wordpress'] = _ApiClient["default"].convertToType(data['wordpress'], [Object]);
        }
      }
      return obj;
    }
  }]);
  return ServiceVersionDetail;
}();
/**
 * Whether this is the active version or not.
 * @member {Boolean} active
 * @default false
 */
ServiceVersionDetail.prototype['active'] = false;

/**
 * A freeform descriptive note.
 * @member {String} comment
 */
ServiceVersionDetail.prototype['comment'] = undefined;

/**
 * Unused at this time.
 * @member {Boolean} deployed
 */
ServiceVersionDetail.prototype['deployed'] = undefined;

/**
 * Whether this version is locked or not. Objects can not be added or edited on locked versions.
 * @member {Boolean} locked
 * @default false
 */
ServiceVersionDetail.prototype['locked'] = false;

/**
 * The number of this version.
 * @member {Number} number
 */
ServiceVersionDetail.prototype['number'] = undefined;

/**
 * Unused at this time.
 * @member {Boolean} staging
 * @default false
 */
ServiceVersionDetail.prototype['staging'] = false;

/**
 * Unused at this time.
 * @member {Boolean} testing
 * @default false
 */
ServiceVersionDetail.prototype['testing'] = false;

/**
 * Date and time in ISO 8601 format.
 * @member {Date} created_at
 */
ServiceVersionDetail.prototype['created_at'] = undefined;

/**
 * Date and time in ISO 8601 format.
 * @member {Date} deleted_at
 */
ServiceVersionDetail.prototype['deleted_at'] = undefined;

/**
 * Date and time in ISO 8601 format.
 * @member {Date} updated_at
 */
ServiceVersionDetail.prototype['updated_at'] = undefined;

/**
 * @member {String} service_id
 */
ServiceVersionDetail.prototype['service_id'] = undefined;

/**
 * List of backends associated to this service.
 * @member {Array.<module:model/BackendResponse>} backends
 */
ServiceVersionDetail.prototype['backends'] = undefined;

/**
 * List of cache settings associated to this service.
 * @member {Array.<module:model/CacheSettingResponse>} cache_settings
 */
ServiceVersionDetail.prototype['cache_settings'] = undefined;

/**
 * List of conditions associated to this service.
 * @member {Array.<module:model/ConditionResponse>} conditions
 */
ServiceVersionDetail.prototype['conditions'] = undefined;

/**
 * List of directors associated to this service.
 * @member {Array.<module:model/Director>} directors
 */
ServiceVersionDetail.prototype['directors'] = undefined;

/**
 * List of domains associated to this service.
 * @member {Array.<module:model/DomainResponse>} domains
 */
ServiceVersionDetail.prototype['domains'] = undefined;

/**
 * List of gzip rules associated to this service.
 * @member {Array.<module:model/GzipResponse>} gzips
 */
ServiceVersionDetail.prototype['gzips'] = undefined;

/**
 * List of headers associated to this service.
 * @member {Array.<module:model/HeaderResponse>} headers
 */
ServiceVersionDetail.prototype['headers'] = undefined;

/**
 * List of healthchecks associated to this service.
 * @member {Array.<module:model/HealthcheckResponse>} healthchecks
 */
ServiceVersionDetail.prototype['healthchecks'] = undefined;

/**
 * List of request settings for this service.
 * @member {Array.<module:model/RequestSettingsResponse>} request_settings
 */
ServiceVersionDetail.prototype['request_settings'] = undefined;

/**
 * List of response objects for this service.
 * @member {Array.<module:model/ResponseObjectResponse>} response_objects
 */
ServiceVersionDetail.prototype['response_objects'] = undefined;

/**
 * @member {module:model/VersionDetailSettings} settings
 */
ServiceVersionDetail.prototype['settings'] = undefined;

/**
 * List of VCL snippets for this service.
 * @member {Array.<module:model/SchemasSnippetResponse>} snippets
 */
ServiceVersionDetail.prototype['snippets'] = undefined;

/**
 * List of VCL files for this service.
 * @member {Array.<module:model/SchemasVclResponse>} vcls
 */
ServiceVersionDetail.prototype['vcls'] = undefined;

/**
 * A list of Wordpress rules with this service.
 * @member {Array.<Object>} wordpress
 */
ServiceVersionDetail.prototype['wordpress'] = undefined;

// Implement SchemasVersionResponse interface:
/**
 * Whether this is the active version or not.
 * @member {Boolean} active
 * @default false
 */
_SchemasVersionResponse["default"].prototype['active'] = false;
/**
 * A freeform descriptive note.
 * @member {String} comment
 */
_SchemasVersionResponse["default"].prototype['comment'] = undefined;
/**
 * Unused at this time.
 * @member {Boolean} deployed
 */
_SchemasVersionResponse["default"].prototype['deployed'] = undefined;
/**
 * Whether this version is locked or not. Objects can not be added or edited on locked versions.
 * @member {Boolean} locked
 * @default false
 */
_SchemasVersionResponse["default"].prototype['locked'] = false;
/**
 * The number of this version.
 * @member {Number} number
 */
_SchemasVersionResponse["default"].prototype['number'] = undefined;
/**
 * Unused at this time.
 * @member {Boolean} staging
 * @default false
 */
_SchemasVersionResponse["default"].prototype['staging'] = false;
/**
 * Unused at this time.
 * @member {Boolean} testing
 * @default false
 */
_SchemasVersionResponse["default"].prototype['testing'] = false;
/**
 * Date and time in ISO 8601 format.
 * @member {Date} created_at
 */
_SchemasVersionResponse["default"].prototype['created_at'] = undefined;
/**
 * Date and time in ISO 8601 format.
 * @member {Date} deleted_at
 */
_SchemasVersionResponse["default"].prototype['deleted_at'] = undefined;
/**
 * Date and time in ISO 8601 format.
 * @member {Date} updated_at
 */
_SchemasVersionResponse["default"].prototype['updated_at'] = undefined;
/**
 * @member {String} service_id
 */
_SchemasVersionResponse["default"].prototype['service_id'] = undefined;
// Implement VersionDetail interface:
/**
 * List of backends associated to this service.
 * @member {Array.<module:model/BackendResponse>} backends
 */
_VersionDetail["default"].prototype['backends'] = undefined;
/**
 * List of cache settings associated to this service.
 * @member {Array.<module:model/CacheSettingResponse>} cache_settings
 */
_VersionDetail["default"].prototype['cache_settings'] = undefined;
/**
 * List of conditions associated to this service.
 * @member {Array.<module:model/ConditionResponse>} conditions
 */
_VersionDetail["default"].prototype['conditions'] = undefined;
/**
 * List of directors associated to this service.
 * @member {Array.<module:model/Director>} directors
 */
_VersionDetail["default"].prototype['directors'] = undefined;
/**
 * List of domains associated to this service.
 * @member {Array.<module:model/DomainResponse>} domains
 */
_VersionDetail["default"].prototype['domains'] = undefined;
/**
 * List of gzip rules associated to this service.
 * @member {Array.<module:model/GzipResponse>} gzips
 */
_VersionDetail["default"].prototype['gzips'] = undefined;
/**
 * List of headers associated to this service.
 * @member {Array.<module:model/HeaderResponse>} headers
 */
_VersionDetail["default"].prototype['headers'] = undefined;
/**
 * List of healthchecks associated to this service.
 * @member {Array.<module:model/HealthcheckResponse>} healthchecks
 */
_VersionDetail["default"].prototype['healthchecks'] = undefined;
/**
 * List of request settings for this service.
 * @member {Array.<module:model/RequestSettingsResponse>} request_settings
 */
_VersionDetail["default"].prototype['request_settings'] = undefined;
/**
 * List of response objects for this service.
 * @member {Array.<module:model/ResponseObjectResponse>} response_objects
 */
_VersionDetail["default"].prototype['response_objects'] = undefined;
/**
 * @member {module:model/VersionDetailSettings} settings
 */
_VersionDetail["default"].prototype['settings'] = undefined;
/**
 * List of VCL snippets for this service.
 * @member {Array.<module:model/SchemasSnippetResponse>} snippets
 */
_VersionDetail["default"].prototype['snippets'] = undefined;
/**
 * List of VCL files for this service.
 * @member {Array.<module:model/SchemasVclResponse>} vcls
 */
_VersionDetail["default"].prototype['vcls'] = undefined;
/**
 * A list of Wordpress rules with this service.
 * @member {Array.<Object>} wordpress
 */
_VersionDetail["default"].prototype['wordpress'] = undefined;
var _default = ServiceVersionDetail;
exports["default"] = _default;