"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _ServiceIdAndVersion = _interopRequireDefault(require("./ServiceIdAndVersion"));
var _Settings = _interopRequireDefault(require("./Settings"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The SettingsResponse model module.
 * @module model/SettingsResponse
 * @version 7.4.0
 */
var SettingsResponse = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>SettingsResponse</code>.
   * @alias module:model/SettingsResponse
   * @implements module:model/Settings
   * @implements module:model/ServiceIdAndVersion
   */
  function SettingsResponse() {
    _classCallCheck(this, SettingsResponse);
    _Settings["default"].initialize(this);
    _ServiceIdAndVersion["default"].initialize(this);
    SettingsResponse.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(SettingsResponse, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>SettingsResponse</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/SettingsResponse} obj Optional instance to populate.
     * @return {module:model/SettingsResponse} The populated <code>SettingsResponse</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new SettingsResponse();
        _Settings["default"].constructFromObject(data, obj);
        _ServiceIdAndVersion["default"].constructFromObject(data, obj);
        if (data.hasOwnProperty('general.default_host')) {
          obj['general.default_host'] = _ApiClient["default"].convertToType(data['general.default_host'], 'String');
        }
        if (data.hasOwnProperty('general.default_ttl')) {
          obj['general.default_ttl'] = _ApiClient["default"].convertToType(data['general.default_ttl'], 'Number');
        }
        if (data.hasOwnProperty('general.stale_if_error')) {
          obj['general.stale_if_error'] = _ApiClient["default"].convertToType(data['general.stale_if_error'], 'Boolean');
        }
        if (data.hasOwnProperty('general.stale_if_error_ttl')) {
          obj['general.stale_if_error_ttl'] = _ApiClient["default"].convertToType(data['general.stale_if_error_ttl'], 'Number');
        }
        if (data.hasOwnProperty('service_id')) {
          obj['service_id'] = _ApiClient["default"].convertToType(data['service_id'], 'String');
        }
        if (data.hasOwnProperty('version')) {
          obj['version'] = _ApiClient["default"].convertToType(data['version'], 'Number');
        }
      }
      return obj;
    }
  }]);
  return SettingsResponse;
}();
/**
 * The default host name for the version.
 * @member {String} general.default_host
 */
SettingsResponse.prototype['general.default_host'] = undefined;

/**
 * The default time-to-live (TTL) for the version.
 * @member {Number} general.default_ttl
 */
SettingsResponse.prototype['general.default_ttl'] = undefined;

/**
 * Enables serving a stale object if there is an error.
 * @member {Boolean} general.stale_if_error
 * @default false
 */
SettingsResponse.prototype['general.stale_if_error'] = false;

/**
 * The default time-to-live (TTL) for serving the stale object for the version.
 * @member {Number} general.stale_if_error_ttl
 * @default 43200
 */
SettingsResponse.prototype['general.stale_if_error_ttl'] = 43200;

/**
 * @member {String} service_id
 */
SettingsResponse.prototype['service_id'] = undefined;

/**
 * @member {Number} version
 */
SettingsResponse.prototype['version'] = undefined;

// Implement Settings interface:
/**
 * The default host name for the version.
 * @member {String} general.default_host
 */
_Settings["default"].prototype['general.default_host'] = undefined;
/**
 * The default time-to-live (TTL) for the version.
 * @member {Number} general.default_ttl
 */
_Settings["default"].prototype['general.default_ttl'] = undefined;
/**
 * Enables serving a stale object if there is an error.
 * @member {Boolean} general.stale_if_error
 * @default false
 */
_Settings["default"].prototype['general.stale_if_error'] = false;
/**
 * The default time-to-live (TTL) for serving the stale object for the version.
 * @member {Number} general.stale_if_error_ttl
 * @default 43200
 */
_Settings["default"].prototype['general.stale_if_error_ttl'] = 43200;
// Implement ServiceIdAndVersion interface:
/**
 * @member {String} service_id
 */
_ServiceIdAndVersion["default"].prototype['service_id'] = undefined;
/**
 * @member {Number} version
 */
_ServiceIdAndVersion["default"].prototype['version'] = undefined;
var _default = SettingsResponse;
exports["default"] = _default;