"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _Snippet = _interopRequireDefault(require("./Snippet"));
var _SnippetResponseCommon = _interopRequireDefault(require("./SnippetResponseCommon"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The SnippetResponse model module.
 * @module model/SnippetResponse
 * @version 7.4.0
 */
var SnippetResponse = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>SnippetResponse</code>.
   * @alias module:model/SnippetResponse
   * @implements module:model/Snippet
   * @implements module:model/SnippetResponseCommon
   */
  function SnippetResponse() {
    _classCallCheck(this, SnippetResponse);
    _Snippet["default"].initialize(this);
    _SnippetResponseCommon["default"].initialize(this);
    SnippetResponse.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(SnippetResponse, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>SnippetResponse</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/SnippetResponse} obj Optional instance to populate.
     * @return {module:model/SnippetResponse} The populated <code>SnippetResponse</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new SnippetResponse();
        _Snippet["default"].constructFromObject(data, obj);
        _SnippetResponseCommon["default"].constructFromObject(data, obj);
        if (data.hasOwnProperty('name')) {
          obj['name'] = _ApiClient["default"].convertToType(data['name'], 'String');
        }
        if (data.hasOwnProperty('type')) {
          obj['type'] = _ApiClient["default"].convertToType(data['type'], 'String');
        }
        if (data.hasOwnProperty('content')) {
          obj['content'] = _ApiClient["default"].convertToType(data['content'], 'String');
        }
        if (data.hasOwnProperty('priority')) {
          obj['priority'] = _ApiClient["default"].convertToType(data['priority'], 'String');
        }
        if (data.hasOwnProperty('dynamic')) {
          obj['dynamic'] = _ApiClient["default"].convertToType(data['dynamic'], 'String');
        }
        if (data.hasOwnProperty('created_at')) {
          obj['created_at'] = _ApiClient["default"].convertToType(data['created_at'], 'Date');
        }
        if (data.hasOwnProperty('deleted_at')) {
          obj['deleted_at'] = _ApiClient["default"].convertToType(data['deleted_at'], 'Date');
        }
        if (data.hasOwnProperty('updated_at')) {
          obj['updated_at'] = _ApiClient["default"].convertToType(data['updated_at'], 'Date');
        }
        if (data.hasOwnProperty('service_id')) {
          obj['service_id'] = _ApiClient["default"].convertToType(data['service_id'], 'String');
        }
        if (data.hasOwnProperty('version')) {
          obj['version'] = _ApiClient["default"].convertToType(data['version'], 'String');
        }
        if (data.hasOwnProperty('id')) {
          obj['id'] = _ApiClient["default"].convertToType(data['id'], 'String');
        }
      }
      return obj;
    }
  }]);
  return SnippetResponse;
}();
/**
 * The name for the snippet.
 * @member {String} name
 */
SnippetResponse.prototype['name'] = undefined;

/**
 * The location in generated VCL where the snippet should be placed.
 * @member {module:model/SnippetResponse.TypeEnum} type
 */
SnippetResponse.prototype['type'] = undefined;

/**
 * The VCL code that specifies exactly what the snippet does.
 * @member {String} content
 */
SnippetResponse.prototype['content'] = undefined;

/**
 * Priority determines execution order. Lower numbers execute first.
 * @member {String} priority
 * @default '100'
 */
SnippetResponse.prototype['priority'] = '100';

/**
 * Sets the snippet version.
 * @member {module:model/SnippetResponse.DynamicEnum} dynamic
 */
SnippetResponse.prototype['dynamic'] = undefined;

/**
 * Date and time in ISO 8601 format.
 * @member {Date} created_at
 */
SnippetResponse.prototype['created_at'] = undefined;

/**
 * Date and time in ISO 8601 format.
 * @member {Date} deleted_at
 */
SnippetResponse.prototype['deleted_at'] = undefined;

/**
 * Date and time in ISO 8601 format.
 * @member {Date} updated_at
 */
SnippetResponse.prototype['updated_at'] = undefined;

/**
 * @member {String} service_id
 */
SnippetResponse.prototype['service_id'] = undefined;

/**
 * String representing the number identifying a version of the service.
 * @member {String} version
 */
SnippetResponse.prototype['version'] = undefined;

/**
 * @member {String} id
 */
SnippetResponse.prototype['id'] = undefined;

// Implement Snippet interface:
/**
 * The name for the snippet.
 * @member {String} name
 */
_Snippet["default"].prototype['name'] = undefined;
/**
 * The location in generated VCL where the snippet should be placed.
 * @member {module:model/Snippet.TypeEnum} type
 */
_Snippet["default"].prototype['type'] = undefined;
/**
 * The VCL code that specifies exactly what the snippet does.
 * @member {String} content
 */
_Snippet["default"].prototype['content'] = undefined;
/**
 * Priority determines execution order. Lower numbers execute first.
 * @member {String} priority
 * @default '100'
 */
_Snippet["default"].prototype['priority'] = '100';
/**
 * Sets the snippet version.
 * @member {module:model/Snippet.DynamicEnum} dynamic
 */
_Snippet["default"].prototype['dynamic'] = undefined;
// Implement SnippetResponseCommon interface:
/**
 * Date and time in ISO 8601 format.
 * @member {Date} created_at
 */
_SnippetResponseCommon["default"].prototype['created_at'] = undefined;
/**
 * Date and time in ISO 8601 format.
 * @member {Date} deleted_at
 */
_SnippetResponseCommon["default"].prototype['deleted_at'] = undefined;
/**
 * Date and time in ISO 8601 format.
 * @member {Date} updated_at
 */
_SnippetResponseCommon["default"].prototype['updated_at'] = undefined;
/**
 * @member {String} service_id
 */
_SnippetResponseCommon["default"].prototype['service_id'] = undefined;
/**
 * String representing the number identifying a version of the service.
 * @member {String} version
 */
_SnippetResponseCommon["default"].prototype['version'] = undefined;
/**
 * @member {String} id
 */
_SnippetResponseCommon["default"].prototype['id'] = undefined;

/**
 * Allowed values for the <code>type</code> property.
 * @enum {String}
 * @readonly
 */
SnippetResponse['TypeEnum'] = {
  /**
   * value: "init"
   * @const
   */
  "init": "init",
  /**
   * value: "recv"
   * @const
   */
  "recv": "recv",
  /**
   * value: "hash"
   * @const
   */
  "hash": "hash",
  /**
   * value: "hit"
   * @const
   */
  "hit": "hit",
  /**
   * value: "miss"
   * @const
   */
  "miss": "miss",
  /**
   * value: "pass"
   * @const
   */
  "pass": "pass",
  /**
   * value: "fetch"
   * @const
   */
  "fetch": "fetch",
  /**
   * value: "error"
   * @const
   */
  "error": "error",
  /**
   * value: "deliver"
   * @const
   */
  "deliver": "deliver",
  /**
   * value: "log"
   * @const
   */
  "log": "log",
  /**
   * value: "none"
   * @const
   */
  "none": "none"
};

/**
 * Allowed values for the <code>dynamic</code> property.
 * @enum {String}
 * @readonly
 */
SnippetResponse['DynamicEnum'] = {
  /**
   * value: "0"
   * @const
   */
  "regular": "0",
  /**
   * value: "1"
   * @const
   */
  "dynamic": "1"
};
var _default = SnippetResponse;
exports["default"] = _default;