"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _Timestamps = _interopRequireDefault(require("./Timestamps"));
var _TlsConfigurationResponseAttributesAllOf = _interopRequireDefault(require("./TlsConfigurationResponseAttributesAllOf"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The TlsConfigurationResponseAttributes model module.
 * @module model/TlsConfigurationResponseAttributes
 * @version 7.4.0
 */
var TlsConfigurationResponseAttributes = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>TlsConfigurationResponseAttributes</code>.
   * @alias module:model/TlsConfigurationResponseAttributes
   * @implements module:model/Timestamps
   * @implements module:model/TlsConfigurationResponseAttributesAllOf
   */
  function TlsConfigurationResponseAttributes() {
    _classCallCheck(this, TlsConfigurationResponseAttributes);
    _Timestamps["default"].initialize(this);
    _TlsConfigurationResponseAttributesAllOf["default"].initialize(this);
    TlsConfigurationResponseAttributes.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(TlsConfigurationResponseAttributes, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>TlsConfigurationResponseAttributes</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/TlsConfigurationResponseAttributes} obj Optional instance to populate.
     * @return {module:model/TlsConfigurationResponseAttributes} The populated <code>TlsConfigurationResponseAttributes</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new TlsConfigurationResponseAttributes();
        _Timestamps["default"].constructFromObject(data, obj);
        _TlsConfigurationResponseAttributesAllOf["default"].constructFromObject(data, obj);
        if (data.hasOwnProperty('created_at')) {
          obj['created_at'] = _ApiClient["default"].convertToType(data['created_at'], 'Date');
        }
        if (data.hasOwnProperty('deleted_at')) {
          obj['deleted_at'] = _ApiClient["default"].convertToType(data['deleted_at'], 'Date');
        }
        if (data.hasOwnProperty('updated_at')) {
          obj['updated_at'] = _ApiClient["default"].convertToType(data['updated_at'], 'Date');
        }
        if (data.hasOwnProperty('default')) {
          obj['default'] = _ApiClient["default"].convertToType(data['default'], 'Boolean');
        }
        if (data.hasOwnProperty('http_protocols')) {
          obj['http_protocols'] = _ApiClient["default"].convertToType(data['http_protocols'], ['String']);
        }
        if (data.hasOwnProperty('tls_protocols')) {
          obj['tls_protocols'] = _ApiClient["default"].convertToType(data['tls_protocols'], ['String']);
        }
        if (data.hasOwnProperty('bulk')) {
          obj['bulk'] = _ApiClient["default"].convertToType(data['bulk'], 'Boolean');
        }
      }
      return obj;
    }
  }]);
  return TlsConfigurationResponseAttributes;
}();
/**
 * Date and time in ISO 8601 format.
 * @member {Date} created_at
 */
TlsConfigurationResponseAttributes.prototype['created_at'] = undefined;

/**
 * Date and time in ISO 8601 format.
 * @member {Date} deleted_at
 */
TlsConfigurationResponseAttributes.prototype['deleted_at'] = undefined;

/**
 * Date and time in ISO 8601 format.
 * @member {Date} updated_at
 */
TlsConfigurationResponseAttributes.prototype['updated_at'] = undefined;

/**
 * Signifies whether or not Fastly will use this configuration as a default when creating a new [TLS Activation](https://www.fastly.com/documentation/reference/api/tls/custom-certs/activations/).
 * @member {Boolean} default
 */
TlsConfigurationResponseAttributes.prototype['default'] = undefined;

/**
 * HTTP protocols available on your configuration.
 * @member {Array.<String>} http_protocols
 */
TlsConfigurationResponseAttributes.prototype['http_protocols'] = undefined;

/**
 * TLS protocols available on your configuration.
 * @member {Array.<String>} tls_protocols
 */
TlsConfigurationResponseAttributes.prototype['tls_protocols'] = undefined;

/**
 * Signifies whether the configuration is used for Platform TLS or not.
 * @member {Boolean} bulk
 */
TlsConfigurationResponseAttributes.prototype['bulk'] = undefined;

// Implement Timestamps interface:
/**
 * Date and time in ISO 8601 format.
 * @member {Date} created_at
 */
_Timestamps["default"].prototype['created_at'] = undefined;
/**
 * Date and time in ISO 8601 format.
 * @member {Date} deleted_at
 */
_Timestamps["default"].prototype['deleted_at'] = undefined;
/**
 * Date and time in ISO 8601 format.
 * @member {Date} updated_at
 */
_Timestamps["default"].prototype['updated_at'] = undefined;
// Implement TlsConfigurationResponseAttributesAllOf interface:
/**
 * Signifies whether or not Fastly will use this configuration as a default when creating a new [TLS Activation](https://www.fastly.com/documentation/reference/api/tls/custom-certs/activations/).
 * @member {Boolean} default
 */
_TlsConfigurationResponseAttributesAllOf["default"].prototype['default'] = undefined;
/**
 * HTTP protocols available on your configuration.
 * @member {Array.<String>} http_protocols
 */
_TlsConfigurationResponseAttributesAllOf["default"].prototype['http_protocols'] = undefined;
/**
 * TLS protocols available on your configuration.
 * @member {Array.<String>} tls_protocols
 */
_TlsConfigurationResponseAttributesAllOf["default"].prototype['tls_protocols'] = undefined;
/**
 * Signifies whether the configuration is used for Platform TLS or not.
 * @member {Boolean} bulk
 */
_TlsConfigurationResponseAttributesAllOf["default"].prototype['bulk'] = undefined;
var _default = TlsConfigurationResponseAttributes;
exports["default"] = _default;