"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The TlsCsrDataAttributes model module.
 * @module model/TlsCsrDataAttributes
 * @version 7.4.0
 */
var TlsCsrDataAttributes = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>TlsCsrDataAttributes</code>.
   * @alias module:model/TlsCsrDataAttributes
   * @param sans {Array.<String>} Subject Alternate Names - An array of one or more fully qualified domain names or public IP addresses to be secured by this certificate. Required.
   */
  function TlsCsrDataAttributes(sans) {
    _classCallCheck(this, TlsCsrDataAttributes);
    TlsCsrDataAttributes.initialize(this, sans);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(TlsCsrDataAttributes, null, [{
    key: "initialize",
    value: function initialize(obj, sans) {
      obj['sans'] = sans;
    }

    /**
     * Constructs a <code>TlsCsrDataAttributes</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/TlsCsrDataAttributes} obj Optional instance to populate.
     * @return {module:model/TlsCsrDataAttributes} The populated <code>TlsCsrDataAttributes</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new TlsCsrDataAttributes();
        if (data.hasOwnProperty('sans')) {
          obj['sans'] = _ApiClient["default"].convertToType(data['sans'], ['String']);
        }
        if (data.hasOwnProperty('common_name')) {
          obj['common_name'] = _ApiClient["default"].convertToType(data['common_name'], 'String');
        }
        if (data.hasOwnProperty('country')) {
          obj['country'] = _ApiClient["default"].convertToType(data['country'], 'String');
        }
        if (data.hasOwnProperty('state')) {
          obj['state'] = _ApiClient["default"].convertToType(data['state'], 'String');
        }
        if (data.hasOwnProperty('city')) {
          obj['city'] = _ApiClient["default"].convertToType(data['city'], 'String');
        }
        if (data.hasOwnProperty('postal_code')) {
          obj['postal_code'] = _ApiClient["default"].convertToType(data['postal_code'], 'String');
        }
        if (data.hasOwnProperty('street_address')) {
          obj['street_address'] = _ApiClient["default"].convertToType(data['street_address'], 'String');
        }
        if (data.hasOwnProperty('organization')) {
          obj['organization'] = _ApiClient["default"].convertToType(data['organization'], 'String');
        }
        if (data.hasOwnProperty('organizational_unit')) {
          obj['organizational_unit'] = _ApiClient["default"].convertToType(data['organizational_unit'], 'String');
        }
        if (data.hasOwnProperty('email')) {
          obj['email'] = _ApiClient["default"].convertToType(data['email'], 'String');
        }
        if (data.hasOwnProperty('key_type')) {
          obj['key_type'] = _ApiClient["default"].convertToType(data['key_type'], 'String');
        }
      }
      return obj;
    }
  }]);
  return TlsCsrDataAttributes;
}();
/**
 * Subject Alternate Names - An array of one or more fully qualified domain names or public IP addresses to be secured by this certificate. Required.
 * @member {Array.<String>} sans
 */
TlsCsrDataAttributes.prototype['sans'] = undefined;

/**
 * Common Name (CN) - The fully qualified domain name (FQDN) to be secured by this certificate. The common name should be one of the entries in the SANs parameter.
 * @member {String} common_name
 */
TlsCsrDataAttributes.prototype['common_name'] = undefined;

/**
 * Country (C) - The two-letter ISO country code where the organization is located.
 * @member {String} country
 */
TlsCsrDataAttributes.prototype['country'] = undefined;

/**
 * State (S) - The state, province, region, or county where the organization is located. This should not be abbreviated.
 * @member {String} state
 */
TlsCsrDataAttributes.prototype['state'] = undefined;

/**
 * Locality (L) - The locality, city, town, or village where the organization is located.
 * @member {String} city
 */
TlsCsrDataAttributes.prototype['city'] = undefined;

/**
 * Postal Code - The postal code where the organization is located.
 * @member {String} postal_code
 */
TlsCsrDataAttributes.prototype['postal_code'] = undefined;

/**
 * Street Address - The street address where the organization is located.
 * @member {String} street_address
 */
TlsCsrDataAttributes.prototype['street_address'] = undefined;

/**
 * Organization (O) - The legal name of the organization, including any suffixes. This should not be abbreviated.
 * @member {String} organization
 */
TlsCsrDataAttributes.prototype['organization'] = undefined;

/**
 * Organizational Unit (OU) - The internal division of the organization managing the certificate.
 * @member {String} organizational_unit
 */
TlsCsrDataAttributes.prototype['organizational_unit'] = undefined;

/**
 * Email Address (EMAIL) - The organizational contact for this.
 * @member {String} email
 */
TlsCsrDataAttributes.prototype['email'] = undefined;

/**
 * CSR Key Type.
 * @member {module:model/TlsCsrDataAttributes.KeyTypeEnum} key_type
 */
TlsCsrDataAttributes.prototype['key_type'] = undefined;

/**
 * Allowed values for the <code>key_type</code> property.
 * @enum {String}
 * @readonly
 */
TlsCsrDataAttributes['KeyTypeEnum'] = {
  /**
   * value: "RSA2048"
   * @const
   */
  "RSA2048": "RSA2048",
  /**
   * value: "ECDSA256"
   * @const
   */
  "ECDSA256": "ECDSA256"
};
var _default = TlsCsrDataAttributes;
exports["default"] = _default;