"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The TlsSubscriptionDataAttributes model module.
 * @module model/TlsSubscriptionDataAttributes
 * @version 7.4.0
 */
var TlsSubscriptionDataAttributes = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>TlsSubscriptionDataAttributes</code>.
   * @alias module:model/TlsSubscriptionDataAttributes
   */
  function TlsSubscriptionDataAttributes() {
    _classCallCheck(this, TlsSubscriptionDataAttributes);
    TlsSubscriptionDataAttributes.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(TlsSubscriptionDataAttributes, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>TlsSubscriptionDataAttributes</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/TlsSubscriptionDataAttributes} obj Optional instance to populate.
     * @return {module:model/TlsSubscriptionDataAttributes} The populated <code>TlsSubscriptionDataAttributes</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new TlsSubscriptionDataAttributes();
        if (data.hasOwnProperty('certificate_authority')) {
          obj['certificate_authority'] = _ApiClient["default"].convertToType(data['certificate_authority'], 'String');
        }
      }
      return obj;
    }
  }]);
  return TlsSubscriptionDataAttributes;
}();
/**
 * The entity that issues and certifies the TLS certificates for your subscription, either `certainly`, `lets-encrypt`, or `globalsign`. To migrate the subscription from one certificate authority to another, such as to migrate from 'lets-encrypt' to 'certainly',  pass `certificate_authority` to the PATCH endpoint. To migrate from 'globalsign' to 'certainly', contact Fastly Support.
 * @member {module:model/TlsSubscriptionDataAttributes.CertificateAuthorityEnum} certificate_authority
 */
TlsSubscriptionDataAttributes.prototype['certificate_authority'] = undefined;

/**
 * Allowed values for the <code>certificate_authority</code> property.
 * @enum {String}
 * @readonly
 */
TlsSubscriptionDataAttributes['CertificateAuthorityEnum'] = {
  /**
   * value: "certainly"
   * @const
   */
  "certainly": "certainly",
  /**
   * value: "lets-encrypt"
   * @const
   */
  "lets-encrypt": "lets-encrypt",
  /**
   * value: "globalsign"
   * @const
   */
  "globalsign": "globalsign"
};
var _default = TlsSubscriptionDataAttributes;
exports["default"] = _default;