"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _TokensAdditionalProps = _interopRequireDefault(require("./TokensAdditionalProps"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The ValidatorResultDataAttributesMessages model module.
 * @module model/ValidatorResultDataAttributesMessages
 * @version 7.4.0
 */
var ValidatorResultDataAttributesMessages = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>ValidatorResultDataAttributesMessages</code>.
   * @alias module:model/ValidatorResultDataAttributesMessages
   * @param type {String} 
   * @param warning {Boolean} 
   * @param message {String} 
   * @param tokens {Array.<Object.<String, module:model/TokensAdditionalProps>>} 
   */
  function ValidatorResultDataAttributesMessages(type, warning, message, tokens) {
    _classCallCheck(this, ValidatorResultDataAttributesMessages);
    ValidatorResultDataAttributesMessages.initialize(this, type, warning, message, tokens);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(ValidatorResultDataAttributesMessages, null, [{
    key: "initialize",
    value: function initialize(obj, type, warning, message, tokens) {
      obj['type'] = type;
      obj['warning'] = warning;
      obj['message'] = message;
      obj['tokens'] = tokens;
    }

    /**
     * Constructs a <code>ValidatorResultDataAttributesMessages</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/ValidatorResultDataAttributesMessages} obj Optional instance to populate.
     * @return {module:model/ValidatorResultDataAttributesMessages} The populated <code>ValidatorResultDataAttributesMessages</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new ValidatorResultDataAttributesMessages();
        if (data.hasOwnProperty('type')) {
          obj['type'] = _ApiClient["default"].convertToType(data['type'], 'String');
        }
        if (data.hasOwnProperty('warning')) {
          obj['warning'] = _ApiClient["default"].convertToType(data['warning'], 'Boolean');
        }
        if (data.hasOwnProperty('message')) {
          obj['message'] = _ApiClient["default"].convertToType(data['message'], 'String');
        }
        if (data.hasOwnProperty('tokens')) {
          obj['tokens'] = _ApiClient["default"].convertToType(data['tokens'], [{
            'String': _TokensAdditionalProps["default"]
          }]);
        }
      }
      return obj;
    }
  }]);
  return ValidatorResultDataAttributesMessages;
}();
/**
 * @member {String} type
 */
ValidatorResultDataAttributesMessages.prototype['type'] = undefined;

/**
 * @member {Boolean} warning
 */
ValidatorResultDataAttributesMessages.prototype['warning'] = undefined;

/**
 * @member {String} message
 */
ValidatorResultDataAttributesMessages.prototype['message'] = undefined;

/**
 * @member {Array.<Object.<String, module:model/TokensAdditionalProps>>} tokens
 */
ValidatorResultDataAttributesMessages.prototype['tokens'] = undefined;
var _default = ValidatorResultDataAttributesMessages;
exports["default"] = _default;