"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The ValuesDdos model module.
 * @module model/ValuesDdos
 * @version 7.4.0
 */
var ValuesDdos = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>ValuesDdos</code>.
   * The results of the query, optionally filtered and grouped over the requested timespan.
   * @alias module:model/ValuesDdos
   */
  function ValuesDdos() {
    _classCallCheck(this, ValuesDdos);
    ValuesDdos.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(ValuesDdos, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>ValuesDdos</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/ValuesDdos} obj Optional instance to populate.
     * @return {module:model/ValuesDdos} The populated <code>ValuesDdos</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new ValuesDdos();
        if (data.hasOwnProperty('ddos_action_limit_streams_connections')) {
          obj['ddos_action_limit_streams_connections'] = _ApiClient["default"].convertToType(data['ddos_action_limit_streams_connections'], 'Number');
        }
        if (data.hasOwnProperty('ddos_action_limit_streams_requests')) {
          obj['ddos_action_limit_streams_requests'] = _ApiClient["default"].convertToType(data['ddos_action_limit_streams_requests'], 'Number');
        }
        if (data.hasOwnProperty('ddos_action_tarpit_accept')) {
          obj['ddos_action_tarpit_accept'] = _ApiClient["default"].convertToType(data['ddos_action_tarpit_accept'], 'Number');
        }
        if (data.hasOwnProperty('ddos_action_tarpit')) {
          obj['ddos_action_tarpit'] = _ApiClient["default"].convertToType(data['ddos_action_tarpit'], 'Number');
        }
        if (data.hasOwnProperty('ddos_action_close')) {
          obj['ddos_action_close'] = _ApiClient["default"].convertToType(data['ddos_action_close'], 'Number');
        }
        if (data.hasOwnProperty('ddos_action_blackhole')) {
          obj['ddos_action_blackhole'] = _ApiClient["default"].convertToType(data['ddos_action_blackhole'], 'Number');
        }
      }
      return obj;
    }
  }]);
  return ValuesDdos;
}();
/**
 * For HTTP/2, the number of connections the limit-streams action was applied to. The limit-streams action caps the allowed number of concurrent streams in a connection.
 * @member {Number} ddos_action_limit_streams_connections
 */
ValuesDdos.prototype['ddos_action_limit_streams_connections'] = undefined;

/**
 * For HTTP/2, the number of requests made on a connection for which the limit-streams action was taken. The limit-streams action caps the allowed number of concurrent streams in a connection.
 * @member {Number} ddos_action_limit_streams_requests
 */
ValuesDdos.prototype['ddos_action_limit_streams_requests'] = undefined;

/**
 * The number of times the tarpit-accept action was taken. The tarpit-accept action adds a delay when accepting future connections.
 * @member {Number} ddos_action_tarpit_accept
 */
ValuesDdos.prototype['ddos_action_tarpit_accept'] = undefined;

/**
 * The number of times the tarpit action was taken. The tarpit action delays writing the response to the client.
 * @member {Number} ddos_action_tarpit
 */
ValuesDdos.prototype['ddos_action_tarpit'] = undefined;

/**
 * The number of times the close action was taken. The close action aborts the connection as soon as possible. The close action takes effect either right after accept, right after the client hello, or right after the response was sent.
 * @member {Number} ddos_action_close
 */
ValuesDdos.prototype['ddos_action_close'] = undefined;

/**
 * The number of times the blackhole action was taken. The blackhole action quietly closes a TCP connection without sending a reset. The blackhole action quietly closes a TCP connection without notifying its peer (all TCP state is dropped).
 * @member {Number} ddos_action_blackhole
 */
ValuesDdos.prototype['ddos_action_blackhole'] = undefined;
var _default = ValuesDdos;
exports["default"] = _default;