"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _IncludedWithWafActiveRuleItem = _interopRequireDefault(require("./IncludedWithWafActiveRuleItem"));
var _Pagination = _interopRequireDefault(require("./Pagination"));
var _PaginationLinks = _interopRequireDefault(require("./PaginationLinks"));
var _PaginationMeta = _interopRequireDefault(require("./PaginationMeta"));
var _WafActiveRuleResponseData = _interopRequireDefault(require("./WafActiveRuleResponseData"));
var _WafActiveRulesResponseAllOf = _interopRequireDefault(require("./WafActiveRulesResponseAllOf"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The WafActiveRulesResponse model module.
 * @module model/WafActiveRulesResponse
 * @version 7.4.0
 */
var WafActiveRulesResponse = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>WafActiveRulesResponse</code>.
   * @alias module:model/WafActiveRulesResponse
   * @implements module:model/Pagination
   * @implements module:model/WafActiveRulesResponseAllOf
   */
  function WafActiveRulesResponse() {
    _classCallCheck(this, WafActiveRulesResponse);
    _Pagination["default"].initialize(this);
    _WafActiveRulesResponseAllOf["default"].initialize(this);
    WafActiveRulesResponse.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(WafActiveRulesResponse, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>WafActiveRulesResponse</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/WafActiveRulesResponse} obj Optional instance to populate.
     * @return {module:model/WafActiveRulesResponse} The populated <code>WafActiveRulesResponse</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new WafActiveRulesResponse();
        _Pagination["default"].constructFromObject(data, obj);
        _WafActiveRulesResponseAllOf["default"].constructFromObject(data, obj);
        if (data.hasOwnProperty('links')) {
          obj['links'] = _PaginationLinks["default"].constructFromObject(data['links']);
        }
        if (data.hasOwnProperty('meta')) {
          obj['meta'] = _PaginationMeta["default"].constructFromObject(data['meta']);
        }
        if (data.hasOwnProperty('data')) {
          obj['data'] = _ApiClient["default"].convertToType(data['data'], [_WafActiveRuleResponseData["default"]]);
        }
        if (data.hasOwnProperty('included')) {
          obj['included'] = _ApiClient["default"].convertToType(data['included'], [_IncludedWithWafActiveRuleItem["default"]]);
        }
      }
      return obj;
    }
  }]);
  return WafActiveRulesResponse;
}();
/**
 * @member {module:model/PaginationLinks} links
 */
WafActiveRulesResponse.prototype['links'] = undefined;

/**
 * @member {module:model/PaginationMeta} meta
 */
WafActiveRulesResponse.prototype['meta'] = undefined;

/**
 * @member {Array.<module:model/WafActiveRuleResponseData>} data
 */
WafActiveRulesResponse.prototype['data'] = undefined;

/**
 * @member {Array.<module:model/IncludedWithWafActiveRuleItem>} included
 */
WafActiveRulesResponse.prototype['included'] = undefined;

// Implement Pagination interface:
/**
 * @member {module:model/PaginationLinks} links
 */
_Pagination["default"].prototype['links'] = undefined;
/**
 * @member {module:model/PaginationMeta} meta
 */
_Pagination["default"].prototype['meta'] = undefined;
// Implement WafActiveRulesResponseAllOf interface:
/**
 * @member {Array.<module:model/WafActiveRuleResponseData>} data
 */
_WafActiveRulesResponseAllOf["default"].prototype['data'] = undefined;
/**
 * @member {Array.<module:model/IncludedWithWafActiveRuleItem>} included
 */
_WafActiveRulesResponseAllOf["default"].prototype['included'] = undefined;
var _default = WafActiveRulesResponse;
exports["default"] = _default;