"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _TypeWafExclusion = _interopRequireDefault(require("./TypeWafExclusion"));
var _WafExclusionData = _interopRequireDefault(require("./WafExclusionData"));
var _WafExclusionResponseDataAllOf = _interopRequireDefault(require("./WafExclusionResponseDataAllOf"));
var _WafExclusionResponseDataAttributes = _interopRequireDefault(require("./WafExclusionResponseDataAttributes"));
var _WafExclusionResponseDataRelationships = _interopRequireDefault(require("./WafExclusionResponseDataRelationships"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The WafExclusionResponseData model module.
 * @module model/WafExclusionResponseData
 * @version 7.4.0
 */
var WafExclusionResponseData = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>WafExclusionResponseData</code>.
   * @alias module:model/WafExclusionResponseData
   * @implements module:model/WafExclusionData
   * @implements module:model/WafExclusionResponseDataAllOf
   */
  function WafExclusionResponseData() {
    _classCallCheck(this, WafExclusionResponseData);
    _WafExclusionData["default"].initialize(this);
    _WafExclusionResponseDataAllOf["default"].initialize(this);
    WafExclusionResponseData.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(WafExclusionResponseData, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>WafExclusionResponseData</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/WafExclusionResponseData} obj Optional instance to populate.
     * @return {module:model/WafExclusionResponseData} The populated <code>WafExclusionResponseData</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new WafExclusionResponseData();
        _WafExclusionData["default"].constructFromObject(data, obj);
        _WafExclusionResponseDataAllOf["default"].constructFromObject(data, obj);
        if (data.hasOwnProperty('type')) {
          obj['type'] = _TypeWafExclusion["default"].constructFromObject(data['type']);
        }
        if (data.hasOwnProperty('attributes')) {
          obj['attributes'] = _WafExclusionResponseDataAttributes["default"].constructFromObject(data['attributes']);
        }
        if (data.hasOwnProperty('relationships')) {
          obj['relationships'] = _WafExclusionResponseDataRelationships["default"].constructFromObject(data['relationships']);
        }
        if (data.hasOwnProperty('id')) {
          obj['id'] = _ApiClient["default"].convertToType(data['id'], 'String');
        }
      }
      return obj;
    }
  }]);
  return WafExclusionResponseData;
}();
/**
 * @member {module:model/TypeWafExclusion} type
 */
WafExclusionResponseData.prototype['type'] = undefined;

/**
 * @member {module:model/WafExclusionResponseDataAttributes} attributes
 */
WafExclusionResponseData.prototype['attributes'] = undefined;

/**
 * @member {module:model/WafExclusionResponseDataRelationships} relationships
 */
WafExclusionResponseData.prototype['relationships'] = undefined;

/**
 * Alphanumeric string identifying a WAF exclusion.
 * @member {String} id
 */
WafExclusionResponseData.prototype['id'] = undefined;

// Implement WafExclusionData interface:
/**
 * @member {module:model/TypeWafExclusion} type
 */
_WafExclusionData["default"].prototype['type'] = undefined;
/**
 * @member {module:model/WafExclusionDataAttributes} attributes
 */
_WafExclusionData["default"].prototype['attributes'] = undefined;
/**
 * @member {module:model/RelationshipsForWafExclusion} relationships
 */
_WafExclusionData["default"].prototype['relationships'] = undefined;
// Implement WafExclusionResponseDataAllOf interface:
/**
 * Alphanumeric string identifying a WAF exclusion.
 * @member {String} id
 */
_WafExclusionResponseDataAllOf["default"].prototype['id'] = undefined;
/**
 * @member {module:model/WafExclusionResponseDataAttributes} attributes
 */
_WafExclusionResponseDataAllOf["default"].prototype['attributes'] = undefined;
/**
 * @member {module:model/WafExclusionResponseDataRelationships} relationships
 */
_WafExclusionResponseDataAllOf["default"].prototype['relationships'] = undefined;
var _default = WafExclusionResponseData;
exports["default"] = _default;