"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _RelationshipsForWafFirewallVersion = _interopRequireDefault(require("./RelationshipsForWafFirewallVersion"));
var _TypeWafFirewallVersion = _interopRequireDefault(require("./TypeWafFirewallVersion"));
var _WafFirewallVersionData = _interopRequireDefault(require("./WafFirewallVersionData"));
var _WafFirewallVersionResponseDataAllOf = _interopRequireDefault(require("./WafFirewallVersionResponseDataAllOf"));
var _WafFirewallVersionResponseDataAttributes = _interopRequireDefault(require("./WafFirewallVersionResponseDataAttributes"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The WafFirewallVersionResponseData model module.
 * @module model/WafFirewallVersionResponseData
 * @version 7.4.0
 */
var WafFirewallVersionResponseData = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>WafFirewallVersionResponseData</code>.
   * @alias module:model/WafFirewallVersionResponseData
   * @implements module:model/WafFirewallVersionData
   * @implements module:model/WafFirewallVersionResponseDataAllOf
   */
  function WafFirewallVersionResponseData() {
    _classCallCheck(this, WafFirewallVersionResponseData);
    _WafFirewallVersionData["default"].initialize(this);
    _WafFirewallVersionResponseDataAllOf["default"].initialize(this);
    WafFirewallVersionResponseData.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(WafFirewallVersionResponseData, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>WafFirewallVersionResponseData</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/WafFirewallVersionResponseData} obj Optional instance to populate.
     * @return {module:model/WafFirewallVersionResponseData} The populated <code>WafFirewallVersionResponseData</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new WafFirewallVersionResponseData();
        _WafFirewallVersionData["default"].constructFromObject(data, obj);
        _WafFirewallVersionResponseDataAllOf["default"].constructFromObject(data, obj);
        if (data.hasOwnProperty('type')) {
          obj['type'] = _TypeWafFirewallVersion["default"].constructFromObject(data['type']);
        }
        if (data.hasOwnProperty('attributes')) {
          obj['attributes'] = _WafFirewallVersionResponseDataAttributes["default"].constructFromObject(data['attributes']);
        }
        if (data.hasOwnProperty('id')) {
          obj['id'] = _ApiClient["default"].convertToType(data['id'], 'String');
        }
        if (data.hasOwnProperty('relationships')) {
          obj['relationships'] = _RelationshipsForWafFirewallVersion["default"].constructFromObject(data['relationships']);
        }
      }
      return obj;
    }
  }]);
  return WafFirewallVersionResponseData;
}();
/**
 * @member {module:model/TypeWafFirewallVersion} type
 */
WafFirewallVersionResponseData.prototype['type'] = undefined;

/**
 * @member {module:model/WafFirewallVersionResponseDataAttributes} attributes
 */
WafFirewallVersionResponseData.prototype['attributes'] = undefined;

/**
 * Alphanumeric string identifying a Firewall version.
 * @member {String} id
 */
WafFirewallVersionResponseData.prototype['id'] = undefined;

/**
 * @member {module:model/RelationshipsForWafFirewallVersion} relationships
 */
WafFirewallVersionResponseData.prototype['relationships'] = undefined;

// Implement WafFirewallVersionData interface:
/**
 * @member {module:model/TypeWafFirewallVersion} type
 */
_WafFirewallVersionData["default"].prototype['type'] = undefined;
/**
 * @member {module:model/WafFirewallVersionDataAttributes} attributes
 */
_WafFirewallVersionData["default"].prototype['attributes'] = undefined;
// Implement WafFirewallVersionResponseDataAllOf interface:
/**
 * Alphanumeric string identifying a Firewall version.
 * @member {String} id
 */
_WafFirewallVersionResponseDataAllOf["default"].prototype['id'] = undefined;
/**
 * @member {module:model/WafFirewallVersionResponseDataAttributes} attributes
 */
_WafFirewallVersionResponseDataAllOf["default"].prototype['attributes'] = undefined;
/**
 * @member {module:model/RelationshipsForWafFirewallVersion} relationships
 */
_WafFirewallVersionResponseDataAllOf["default"].prototype['relationships'] = undefined;
var _default = WafFirewallVersionResponseData;
exports["default"] = _default;