"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The WafRuleAttributes model module.
 * @module model/WafRuleAttributes
 * @version 7.4.0
 */
var WafRuleAttributes = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>WafRuleAttributes</code>.
   * @alias module:model/WafRuleAttributes
   */
  function WafRuleAttributes() {
    _classCallCheck(this, WafRuleAttributes);
    WafRuleAttributes.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(WafRuleAttributes, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>WafRuleAttributes</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/WafRuleAttributes} obj Optional instance to populate.
     * @return {module:model/WafRuleAttributes} The populated <code>WafRuleAttributes</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new WafRuleAttributes();
        if (data.hasOwnProperty('modsec_rule_id')) {
          obj['modsec_rule_id'] = _ApiClient["default"].convertToType(data['modsec_rule_id'], 'Number');
        }
        if (data.hasOwnProperty('publisher')) {
          obj['publisher'] = _ApiClient["default"].convertToType(data['publisher'], 'String');
        }
        if (data.hasOwnProperty('type')) {
          obj['type'] = _ApiClient["default"].convertToType(data['type'], 'String');
        }
      }
      return obj;
    }
  }]);
  return WafRuleAttributes;
}();
/**
 * Corresponding ModSecurity rule ID.
 * @member {Number} modsec_rule_id
 */
WafRuleAttributes.prototype['modsec_rule_id'] = undefined;

/**
 * Rule publisher.
 * @member {module:model/WafRuleAttributes.PublisherEnum} publisher
 */
WafRuleAttributes.prototype['publisher'] = undefined;

/**
 * The rule's [type](https://docs.fastly.com/en/guides/managing-rules-on-the-fastly-waf#understanding-the-types-of-rules).
 * @member {module:model/WafRuleAttributes.TypeEnum} type
 */
WafRuleAttributes.prototype['type'] = undefined;

/**
 * Allowed values for the <code>publisher</code> property.
 * @enum {String}
 * @readonly
 */
WafRuleAttributes['PublisherEnum'] = {
  /**
   * value: "fastly"
   * @const
   */
  "fastly": "fastly",
  /**
   * value: "trustwave"
   * @const
   */
  "trustwave": "trustwave",
  /**
   * value: "owasp"
   * @const
   */
  "owasp": "owasp"
};

/**
 * Allowed values for the <code>type</code> property.
 * @enum {String}
 * @readonly
 */
WafRuleAttributes['TypeEnum'] = {
  /**
   * value: "strict"
   * @const
   */
  "strict": "strict",
  /**
   * value: "score"
   * @const
   */
  "score": "score",
  /**
   * value: "threshold"
   * @const
   */
  "threshold": "threshold"
};
var _default = WafRuleAttributes;
exports["default"] = _default;