"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _RelationshipsForWafRule = _interopRequireDefault(require("./RelationshipsForWafRule"));
var _TypeWafRule = _interopRequireDefault(require("./TypeWafRule"));
var _WafRule = _interopRequireDefault(require("./WafRule"));
var _WafRuleAttributes = _interopRequireDefault(require("./WafRuleAttributes"));
var _WafRuleResponseDataAllOf = _interopRequireDefault(require("./WafRuleResponseDataAllOf"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The WafRuleResponseData model module.
 * @module model/WafRuleResponseData
 * @version 7.4.0
 */
var WafRuleResponseData = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>WafRuleResponseData</code>.
   * @alias module:model/WafRuleResponseData
   * @implements module:model/WafRule
   * @implements module:model/WafRuleResponseDataAllOf
   */
  function WafRuleResponseData() {
    _classCallCheck(this, WafRuleResponseData);
    _WafRule["default"].initialize(this);
    _WafRuleResponseDataAllOf["default"].initialize(this);
    WafRuleResponseData.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(WafRuleResponseData, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>WafRuleResponseData</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/WafRuleResponseData} obj Optional instance to populate.
     * @return {module:model/WafRuleResponseData} The populated <code>WafRuleResponseData</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new WafRuleResponseData();
        _WafRule["default"].constructFromObject(data, obj);
        _WafRuleResponseDataAllOf["default"].constructFromObject(data, obj);
        if (data.hasOwnProperty('type')) {
          obj['type'] = _TypeWafRule["default"].constructFromObject(data['type']);
        }
        if (data.hasOwnProperty('id')) {
          obj['id'] = _ApiClient["default"].convertToType(data['id'], 'String');
        }
        if (data.hasOwnProperty('attributes')) {
          obj['attributes'] = _WafRuleAttributes["default"].constructFromObject(data['attributes']);
        }
        if (data.hasOwnProperty('relationships')) {
          obj['relationships'] = _RelationshipsForWafRule["default"].constructFromObject(data['relationships']);
        }
      }
      return obj;
    }
  }]);
  return WafRuleResponseData;
}();
/**
 * @member {module:model/TypeWafRule} type
 */
WafRuleResponseData.prototype['type'] = undefined;

/**
 * @member {String} id
 */
WafRuleResponseData.prototype['id'] = undefined;

/**
 * @member {module:model/WafRuleAttributes} attributes
 */
WafRuleResponseData.prototype['attributes'] = undefined;

/**
 * @member {module:model/RelationshipsForWafRule} relationships
 */
WafRuleResponseData.prototype['relationships'] = undefined;

// Implement WafRule interface:
/**
 * @member {module:model/TypeWafRule} type
 */
_WafRule["default"].prototype['type'] = undefined;
/**
 * @member {String} id
 */
_WafRule["default"].prototype['id'] = undefined;
/**
 * @member {module:model/WafRuleAttributes} attributes
 */
_WafRule["default"].prototype['attributes'] = undefined;
// Implement WafRuleResponseDataAllOf interface:
/**
 * @member {module:model/RelationshipsForWafRule} relationships
 */
_WafRuleResponseDataAllOf["default"].prototype['relationships'] = undefined;
var _default = WafRuleResponseData;
exports["default"] = _default;