"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://www.fastly.com/documentation/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The WafRuleRevisionAttributes model module.
 * @module model/WafRuleRevisionAttributes
 * @version 7.4.0
 */
var WafRuleRevisionAttributes = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>WafRuleRevisionAttributes</code>.
   * @alias module:model/WafRuleRevisionAttributes
   */
  function WafRuleRevisionAttributes() {
    _classCallCheck(this, WafRuleRevisionAttributes);
    WafRuleRevisionAttributes.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(WafRuleRevisionAttributes, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>WafRuleRevisionAttributes</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/WafRuleRevisionAttributes} obj Optional instance to populate.
     * @return {module:model/WafRuleRevisionAttributes} The populated <code>WafRuleRevisionAttributes</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new WafRuleRevisionAttributes();
        if (data.hasOwnProperty('message')) {
          obj['message'] = _ApiClient["default"].convertToType(data['message'], 'String');
        }
        if (data.hasOwnProperty('modsec_rule_id')) {
          obj['modsec_rule_id'] = _ApiClient["default"].convertToType(data['modsec_rule_id'], 'Number');
        }
        if (data.hasOwnProperty('paranoia_level')) {
          obj['paranoia_level'] = _ApiClient["default"].convertToType(data['paranoia_level'], 'Number');
        }
        if (data.hasOwnProperty('revision')) {
          obj['revision'] = _ApiClient["default"].convertToType(data['revision'], 'Number');
        }
        if (data.hasOwnProperty('severity')) {
          obj['severity'] = _ApiClient["default"].convertToType(data['severity'], 'Number');
        }
        if (data.hasOwnProperty('source')) {
          obj['source'] = _ApiClient["default"].convertToType(data['source'], 'String');
        }
        if (data.hasOwnProperty('state')) {
          obj['state'] = _ApiClient["default"].convertToType(data['state'], 'String');
        }
        if (data.hasOwnProperty('vcl')) {
          obj['vcl'] = _ApiClient["default"].convertToType(data['vcl'], 'String');
        }
      }
      return obj;
    }
  }]);
  return WafRuleRevisionAttributes;
}();
/**
 * Message metadata for the rule.
 * @member {String} message
 */
WafRuleRevisionAttributes.prototype['message'] = undefined;

/**
 * Corresponding ModSecurity rule ID.
 * @member {Number} modsec_rule_id
 */
WafRuleRevisionAttributes.prototype['modsec_rule_id'] = undefined;

/**
 * Paranoia level for the rule.
 * @member {Number} paranoia_level
 */
WafRuleRevisionAttributes.prototype['paranoia_level'] = undefined;

/**
 * Revision number.
 * @member {Number} revision
 */
WafRuleRevisionAttributes.prototype['revision'] = undefined;

/**
 * Severity metadata for the rule.
 * @member {Number} severity
 */
WafRuleRevisionAttributes.prototype['severity'] = undefined;

/**
 * The ModSecurity rule logic.
 * @member {String} source
 */
WafRuleRevisionAttributes.prototype['source'] = undefined;

/**
 * The state, indicating if the revision is the most recent version of the rule.
 * @member {module:model/WafRuleRevisionAttributes.StateEnum} state
 */
WafRuleRevisionAttributes.prototype['state'] = undefined;

/**
 * The VCL representation of the rule logic.
 * @member {String} vcl
 */
WafRuleRevisionAttributes.prototype['vcl'] = undefined;

/**
 * Allowed values for the <code>state</code> property.
 * @enum {String}
 * @readonly
 */
WafRuleRevisionAttributes['StateEnum'] = {
  /**
   * value: "latest"
   * @const
   */
  "latest": "latest",
  /**
   * value: "outdated"
   * @const
   */
  "outdated": "outdated"
};
var _default = WafRuleRevisionAttributes;
exports["default"] = _default;